#define D_MODEPROTP (0 + MODE_N + MODE_T + MODE_S)
#define D_MODEPROTM (0)


void initchannels() {
    int i;
    for (i=0; i < MAXCHANNELS; i++) chantab[i].flags=CHAN_UNUSED;
}

int addchan(char *name, char *key, int cflags) {
    int i, j;
    if (!name) return (-1);
    if (name[0] != '#') return (-1);
    if (strlen(name) < 2) return (-1);
    if (strlen(name) > 128) return (-1);
    if (ischanname(name)) return (-1);
    for (i=0; i < MAXCHANNELS; i++) if (chantab[i].flags & CHAN_UNUSED) {
	bzero(&chantab[i], sizeof(chantab[i]));
	chantab[i].name=(char *) malloc(strlen(name)+1);
	strcpy(chantab[i].name, name);
	chantab[i].flags=0;
	chantab[i].cflags=cflags;
	chantab[i].cmdcount=0;
	chantab[i].topic=NULL;
	if (key && key[0] && (strlen(key) < 64)) {
	    chantab[i].key=(char *) malloc(strlen(key)+1);
	    strcpy(chantab[i].key, key);
	} else chantab[i].key=NULL;
	chantab[i].topicprot=NULL;
	chantab[i].keyprot=NULL;
	chantab[i].mode=0;
	chantab[i].modeprotp=D_MODEPROTP;
	chantab[i].modeprotm=D_MODEPROTM;
	chantab[i].limit=0;
	chantab[i].conchan=0;
        chantab[i].copped=0;
	chantab[i].crejoin=0;
	chantab[i].cjoin=0;
	chantab[i].cunjoin=0;
	chantab[i].onchan=0;
	chantab[i].opped=0;	
	chantab[i].bans=NULL;
	chantab[i].invites=NULL;
	chantab[i].exempts=NULL;
	chantab[i].bansprot=NULL;
	chantab[i].invitesprot=NULL;
	chantab[i].exemptsprot=NULL;
	chantab[i].usersfirst=NULL;
	chantab[i].userslast=NULL;
// DEFAULTS
	chantab[i].csettings[C_REVANGE]=CS_KICK;
	chantab[i].csettings[C_BITCH]=CS_KICK | CS_KICKVICTIM;
	chantab[i].csettings[C_AFTEROP]=CS_NONE;
	chantab[i].csettings[C_BAN]=CS_NONE;
	chantab[i].csettings[C_EXEMPT]=CS_KICK | CS_REMOVE;
	chantab[i].csettings[C_INVITE]=CS_KICK | CS_REMOVE;
	chantab[i].csettings[C_CHANMODE]=CS_KICK;
	chantab[i].csettings[C_JOIN]=CS_NONE;
        for (j=0; j < MAXCLONES; j++) {
            clonetab[j].channels[i].flags=0;
            clonetab[j].channels[i].join=0;
	    clonetab[j].channels[i].cmdcount=0;
	}
						    
	return i;
    }
    return (-1);
}

int delchanid(int cid) {
    struct suser *u, *u2;
    if (!(chantab[cid].flags & CHAN_UNUSED)) {
	chantab[cid].flags=CHAN_UNUSED;
	if (chantab[cid].name) free(chantab[cid].name);
	if (chantab[cid].key) free(chantab[cid].key);
	if (chantab[cid].topic) free(chantab[cid].topic);
	if (chantab[cid].keyprot) free(chantab[cid].keyprot);
	if (chantab[cid].topicprot) free(chantab[cid].topicprot);
	if (chantab[cid].bans) freemasklist(&chantab[cid].bans);
	if (chantab[cid].exempts) freemasklist(&chantab[cid].exempts);
	if (chantab[cid].invites) freemasklist(&chantab[cid].invites);
	if (chantab[cid].bansprot) freemasklist(&chantab[cid].bansprot);
	if (chantab[cid].exemptsprot) freemasklist(&chantab[cid].exemptsprot);
	if (chantab[cid].invitesprot) freemasklist(&chantab[cid].invitesprot);
	if (chantab[cid].usersfirst) {
	    u=chantab[cid].usersfirst;
	    while (u) {
		u2=u->next;
		if (u->host) free(u->host);
		free(u);
		u=u2;
	    }
	}
	return 1;
    }
    return 0;
}

int delchanname(char *name) {
    int i;
    if (!name) return 0;
    if (name[0] != '#') return 0;
    if (strlen(name) < 2) return 0;
    if (strlen(name) > 128) return 0;
    for (i=0; i < MAXCHANNELS; i++) if (!(chantab[i].flags & CHAN_UNUSED)) {
	if (strcasecmp(chantab[i].name, name) == 0) {
	    return delchanid(i);
	}
    }
    return 0;
}

int ischanid(int cid) {
    return (!(chantab[cid].flags & CHAN_UNUSED));
}

int ischanname(char *name) {
    int i;
    if (!name) return 0;
    if (name[0] != '#') return 0;
    if (strlen(name) < 2) return 0;
    if (strlen(name) > 128) return 0;
    for (i=0; i < MAXCHANNELS; i++) if (!(chantab[i].flags & CHAN_UNUSED))
	if (strcasecmp(chantab[i].name, name) == 0) return 1;
    return 0;
}

int findchanname(char *name) {
    int i;
    if (!name) return (-1);
    if (name[0] != '#') return (-1);
    if (strlen(name) < 2) return (-1);
    if (strlen(name) > 128) return (-1);
    for (i=0; i < MAXCHANNELS; i++) if (!(chantab[i].flags & CHAN_UNUSED))
	if (strcasecmp(chantab[i].name, name) == 0) return i;
    return -1;
}

int enablejoinchanid(int cid) {
    if (cid >= MAXCHANNELS) return 0;
    if (chantab[cid].flags & CHAN_UNUSED) return;
    chantab[cid].flags|=CHAN_JOIN;
}

int disablejoinchanid(int cid) {
    if (cid >= MAXCHANNELS) return 0;
    if (chantab[cid].flags & CHAN_UNUSED) return;
    chantab[cid].flags&=~CHAN_JOIN;
}

int enablejoinchanname(char *chan) {
    int cid;
    cid=findchanname(chan);
    if (cid < 0) return 0;
    chantab[cid].flags|=CHAN_JOIN;
}

int disablejoinchanname(char *chan) {
    int cid;
    cid=findchanname(chan);
    if (cid < 0) return 0;
    chantab[cid].flags&=~CHAN_JOIN;
}

struct suser *addchanuserid(int cid, char *nick, char *host, int flags) {
    struct suser *p;
    if (chantab[cid].flags & CHAN_UNUSED) return NULL;
    if (!nick) return NULL;
    if (!nick[0] || (strlen(nick) > 9)) return NULL;
    p=chantab[cid].usersfirst;
    while (p) {
	if (strcasecmp(p->nick, nick) == 0) {
	    if ((p->host == NULL) && host && host[0]) {
		p->flags|=USER_HOST;
		p->host=(char *) malloc(strlen(host)+strlen(nick)+2);
		sprintf(p->host, "%s!%s", nick, host);
		p->handle=ulfindhandlehost(p->host);
	    } else if (p->host) p->flags&=~USER_HOST;
	    p->flags|=USER_ALREADY;
	    return p;
	}
	p=p->next;
    }
    p=(struct suser *) malloc(sizeof(struct suser));
    strcpy(p->nick, nick);
    if (host && host[0]) {
	p->host=(char *) malloc(strlen(host)+strlen(nick)+2);
	sprintf(p->host, "%s!%s", nick, host);
	p->handle=ulfindhandlehost(p->host);
    } else {
	p->host=NULL;
	p->handle=NULL;
    }
    p->flags=flags;
    p->next=NULL;
    if (chantab[cid].userslast) {
	chantab[cid].userslast->next=p;
	chantab[cid].userslast=p;
    } else {
	chantab[cid].usersfirst=p;
	chantab[cid].userslast=p;
    }
    return p;
}

struct suser *addchanusername(char *chan, char *nick, char *host, int flags) {
    int i;
    if (!chan) return NULL;
    if (chan[0] != '#') return NULL;
    if (strlen(chan) < 2) return NULL;
    if (strlen(chan) > 128) return NULL;
    for (i=0; i < MAXCHANNELS; i++) if (!(chantab[i].flags & CHAN_UNUSED))
	if (strcasecmp(chantab[i].name, chan) == 0) return addchanuserid(i, nick, host, flags);
    return NULL;
}

int delchanuserid(int cid, char *nick) {
    struct suser *p, *lp;
    if (chantab[cid].flags & CHAN_UNUSED) return 0;
    if (!nick) return 0;
    if (!nick[0] || (strlen(nick) > 9)) return 0;
    lp=NULL;
    p=chantab[cid].usersfirst;
    while (p) {
	if (strcasecmp(p->nick, nick) == 0) {
	    if (lp) {
		lp->next=p->next;
		if (p->next == NULL) chantab[cid].userslast=lp;
		if (p->host) free(p->host);
		free(p);
	    } else {
		chantab[cid].usersfirst=p->next;
		if (p->next == NULL) chantab[cid].userslast=NULL;
		if (p->host) free(p->host);
		free(p);
	    }
	    return 1;
	}
	p=p->next;
	if (lp) lp=lp->next; else lp=chantab[cid].usersfirst;
    }
    return 0;
}

int delchanusername(char *chan, char *nick) {
    int i;
    if (!chan) return 0;
    if (chan[0] != '#') return 0;
    if (strlen(chan) < 2) return 0;
    if (strlen(chan) > 128) return 0;
    for (i=0; i < MAXCHANNELS; i++) if (!(chantab[i].flags & CHAN_UNUSED))
	if (strcasecmp(chantab[i].name, chan) == 0) return delchanuserid(i, nick);
    return 0;
}

struct suser *findchanuserid(int cid, char *nick) {
    struct suser *p;
    if (chantab[cid].flags & CHAN_UNUSED) return NULL;
    if (!nick) return NULL;
    if (!nick[0] || (strlen(nick) > 9)) return NULL;
    p=chantab[cid].usersfirst;
    while (p) {
	if (strcasecmp(p->nick, nick) == 0) return p;
	p=p->next;
    }
    return NULL;
}

struct suser *findchanusername(char *chan, char *nick) {
    int i;
    if (!chan) return NULL;
    if (chan[0] != '#') return NULL;
    if (strlen(chan) < 2) return NULL;
    if (strlen(chan) > 128) return NULL;
    for (i=0; i < MAXCHANNELS; i++) if (!(chantab[i].flags & CHAN_UNUSED))
	if (strcasecmp(chantab[i].name, chan) == 0) return findchanuserid(i, nick);
    return NULL;
}

int matchflagschanuserid(int cid, char *nick, int flags) {
    struct suser *p;
    if (chantab[cid].flags & CHAN_UNUSED) return 0;
    if (!nick) return 0;
    if (!nick[0] || (strlen(nick) > 9)) return 0;
    p=chantab[cid].usersfirst;
    while (p) {
	if (strcasecmp(p->nick, nick) == 0) return (p->flags & flags);
	p=p->next;
    }
    return 0;
}

int matchflagschanusername(char *chan, char *nick, int flags) {
    int i;
    if (!chan) return 0;
    if (chan[0] != '#') return 0;
    if (strlen(chan) < 2) return 0;
    if (strlen(chan) > 128) return 0;
    for (i=0; i < MAXCHANNELS; i++) if (!(chantab[i].flags & CHAN_UNUSED))
	if (strcasecmp(chantab[i].name, chan) == 0) return matchflagschanuserid(i, nick, flags);
    return 0;
}

int ischanuserid(int cid, char *nick) {
    struct suser *p;
    if (chantab[cid].flags & CHAN_UNUSED) return 0;
    if (!nick) return 0;
    if (!nick[0] || (strlen(nick) > 9)) return 0;
    p=chantab[cid].usersfirst;
    while (p) {
	if (strcasecmp(p->nick, nick) == 0) return 1;
	p=p->next;
    }
    return 0;
}

int ischanusername(char *chan, char *nick) {
    int i;
    if (!chan) return 0;
    if (chan[0] != '#') return 0;
    if (strlen(chan) < 2) return 0;
    if (strlen(chan) > 128) return 0;
    for (i=0; i < MAXCHANNELS; i++) if (!(chantab[i].flags & CHAN_UNUSED))
	if (strcasecmp(chantab[i].name, chan) == 0) return ischanuserid(i, nick);
    return 0;
}

int isopchannickid(int cid, char *nick) {
    struct suser *p;
    if (chantab[cid].flags & CHAN_UNUSED) return 0;
    if (!nick) return 0;
    if (!nick[0] || (strlen(nick) > 9)) return 0;
    p=chantab[cid].usersfirst;
    while (p) {
	if (strcasecmp(p->nick, nick) == 0) return (p->flags & USER_OP);
	p=p->next;
    }
    return 0;
}

int isopchannickname(char *chan, char *nick) {
    int i;
    if (!chan) return 0;
    if (chan[0] != '#') return 0;
    if (strlen(chan) < 2) return 0;
    if (strlen(chan) > 128) return 0;
    for (i=0; i < MAXCHANNELS; i++) if (!(chantab[i].flags & CHAN_UNUSED))
	if (strcasecmp(chantab[i].name, chan) == 0) return isopchannickid(i, nick);
    return 0;
}

int addchankickid(int cid, char *nick) {
    struct skick *p;
    if (chantab[cid].flags & CHAN_UNUSED) return 0;
    if (!nick) return 0;
    if (!nick[0] || (strlen(nick) > 9)) return 0;
    p=kicklist;
    while (p) {
	if (p->cid == cid) if (strcasecmp(p->nick, nick) == 0) return 1;
	p=p->next;
    }
    p=(struct skick *) malloc(sizeof(struct skick));
    p->cid=cid;
    p->cloneid=(-1);
    strcpy(p->nick, nick);
    p->next=kicklist;
    kicklist=p;
    return 1;
}

int delchankickid(int cid, char *nick) {
    struct skick *p, *p2, *lp;
    if (chantab[cid].flags & CHAN_UNUSED) return 0;
    if (!nick) return 0;
    if (!nick[0] || (strlen(nick) > 9)) return 0;
    p=kicklist;
    lp=NULL;
    if (nick[0] != '*') {
	while (p) {
	    if (p->cid == cid) if (strcasecmp(p->nick, nick) == 0) {
		if (lp) {
		    p2=p->next;
		    lp->next=p2;
		    free(p);
		} else {
		    p2=p->next;
		    kicklist=p2;
		    free(p);
		}
		return 1;
	    }
	    if (lp) lp=lp->next; else lp=kicklist;
	    p=p->next;
	}
    } else {
	while (p) {
	    if (p->cid == cid) {
		if (lp) {
		    p2=p->next;
		    lp->next=p2;
		    free(p);
		    p=p2;
		} else {
		    p2=p->next;
		    kicklist=p2;
		    free(p);
		    p=p2;
		}
	    } else {
		if (lp) lp=lp->next; else if (kicklist != p2) lp=kicklist;
		p=p->next;
	    }
	}
    }
    return 0;
}

int flushchankickid(int cid) {
    struct skick *p;
    char nicklist[60];
    int idx[6];
    int i, ret;
    if (chantab[cid].flags & CHAN_UNUSED) return 0;
    ret=findfreecloneuserflagschanidpenalty(cid, USER_OP);
    if (ret == (-1)) return 0;
    if (ret == (-2)) return 0;
    strcpy(nicklist, "");
    i=0;
    p=kicklist;
    while (p) {
	if ((p->cid == cid) && (p->cloneid == (-1))) {
	    p->cloneid=ret;
	    strcat(nicklist, p->nick);
	    idx[i]=strlen(nicklist);
	    strcat(nicklist, ",");
	    i++;
	    if (clonetab[ret].penalty+8 < MAXPENALTY) {
		if (i == 6) {
		    nicklist[idx[1]]=0;
		    nicklist[idx[5]]=0;
		    printf("KICK %s %s :%s\nKICK %s %s :%s\n", chantab[cid].name, nicklist, randkickreason(), chantab[cid].name, &nicklist[idx[1]+1], randkickreason());
		    dprintf(socktab[clonetab[ret].sid].fd, "KICK %s %s :%s\nKICK %s %s :%s\n", chantab[cid].name, nicklist, randkickreason(), chantab[cid].name, &nicklist[idx[1]+1], randkickreason());
		    clonetab[ret].penalty+=4+3*i;
		    strcpy(nicklist, "");
		    i=0;
		    ret=findfreecloneuserflagschanidpenalty(cid, USER_OP);
		    if (ret == -1) return 0;
		}
	    } else if (clonetab[ret].penalty+5 < MAXPENALTY) {
		if (i == 5) {
		    nicklist[idx[0]]=0;
		    nicklist[idx[4]]=0;
		    printf("KICK %s %s :%s\nKICK %s %s :%s\n", chantab[cid].name, nicklist, randkickreason(), chantab[cid].name, &nicklist[idx[0]+1], randkickreason());
		    dprintf(socktab[clonetab[ret].sid].fd, "KICK %s %s :%s\nKICK %s %s :%s\n", chantab[cid].name, nicklist, randkickreason(), chantab[cid].name, &nicklist[idx[0]+1], randkickreason());
		    clonetab[ret].penalty+=4+3*i;
		    strcpy(nicklist, "");
		    i=0;
		    ret=findfreecloneuserflagschanidpenalty(cid, USER_OP);
		    if (ret == -1) return 0;
		}
	    } else if (i == 4) {
		nicklist[idx[3]]=0;
		printf("KICK %s %s :%s\n", chantab[cid].name, nicklist, randkickreason());
		dprintf(socktab[clonetab[ret].sid].fd, "KICK %s %s :%s\n", chantab[cid].name, nicklist, randkickreason());
		clonetab[ret].penalty+=2+3*i;
		strcpy(nicklist, "");
		i=0;
		ret=findfreecloneuserflagschanidpenalty(cid, USER_OP);
		if (ret == -1) return 0;
	    }
	}
	p=p->next;
    }
    if (i == 6) {
	nicklist[idx[1]]=0;
	nicklist[idx[5]]=0;
	printf("KICK %s %s :%s\nKICK %s %s :%s\n", chantab[cid].name, nicklist, randkickreason(), chantab[cid].name, &nicklist[idx[1]+1], randkickreason());
	dprintf(socktab[clonetab[ret].sid].fd, "KICK %s %s :%s\nKICK %s %s :%s\n", chantab[cid].name, nicklist, randkickreason(), chantab[cid].name, &nicklist[idx[1]+1], randkickreason());
	clonetab[ret].penalty+=4+3*i;
    } else if (i == 5) {
	nicklist[idx[0]]=0;
	nicklist[idx[4]]=0;
	printf("KICK %s %s :%s\nKICK %s %s :%s\n", chantab[cid].name, nicklist, randkickreason(), chantab[cid].name, &nicklist[idx[0]+1], randkickreason());
	dprintf(socktab[clonetab[ret].sid].fd, "KICK %s %s :%s\nKICK %s %s :%s\n", chantab[cid].name, nicklist, randkickreason(), chantab[cid].name, &nicklist[idx[0]+1], randkickreason());
	clonetab[ret].penalty+=4+3*i;
    } else if (i) {
	nicklist[idx[i-1]]=0;
	printf("KICK %s %s :%s\n", chantab[cid].name, nicklist, randkickreason());
	dprintf(socktab[clonetab[ret].sid].fd, "KICK %s %s :%s\n", chantab[cid].name, nicklist, randkickreason());
	clonetab[ret].penalty+=2+3*i;
    }
    return 1;
}

int resendchankickid(int cid, int cloneid) {
    struct skick *p;
    p=kicklist;
    while (p) {
	if ((p->cid == cid) && (p->cloneid == cloneid)) p->cloneid=(-1);
	p=p->next;
    }
}

int flushkick() {
    register int i;
    for (i=0; i < MAXCHANNELS; i++) if (!(chantab[i].flags & CHAN_UNUSED)) flushchankickid(i);
}

void addchanmodeid(int cid, char pm, char mode, char *what) {
    struct smode *p;
    p=modelist;
    while (p) {
	if (p->cid == cid) if (p->mode == mode) {
	    if (!p->what && !what) {
		if (p->cid == (-1)) p->pm=pm;
		return;
	    } else if (strcasecmp(p->what, what) == 0) {
		if (p->cid == (-1)) p->pm=pm;
		return;
	    }
	}
	p=p->next;
    }
    p=(struct smode *) malloc(sizeof(struct smode));
    p->cid=cid;
    p->cloneid=(-1);
    if (what) {
	p->what=(char *) malloc(strlen(what)+1);
	strcpy(p->what, what);
    } else p->what=NULL;
    p->pm=pm;
    p->mode=mode;
    p->next=modelist;
    modelist=p;
//    printf("Adding MODE %c%c %s.\n", pm, mode, what);
}

void delchanmodeid(int cid, char pm, char mode, char *what) {
    struct smode *p, *p2, *lp;
    p=modelist;
    lp=NULL;
    if (pm != '*') {
	while (p) {
	    if ((p->cid == cid) && (p->pm == pm) && (p->mode == mode)) if (strcasecmp(p->what, what) == 0) {
		if (lp) {
		    p2=p->next;
		    lp->next=p2;
		    if (p->what) free(p->what);
		    free(p);
		} else {
		    p2=p->next;
		    modelist=p2;
		    if (p->what) free(p->what);
		    free(p);
		}
		return;
	    }
	    if (lp) lp=lp->next; else lp=modelist;
	    p=p->next;
	}
    } else if (what) {
	while (p) {
	    if (p->cid == cid) if (strcasecmp(p->what, what) == 0) {
		if (lp) {
		    p2=p->next;
		    lp->next=p2;
		    if (p->what) free(p->what);
		    free(p);
		    p=p2;
		} else {
		    p2=p->next;
		    modelist=p2;
		    if (p->what) free(p->what);
		    free(p);
		    p=p2;
		}
	    } else {
		if (lp) lp=lp->next; else if (modelist != p2) lp=modelist;
		p=p->next;
	    }
	}
    } else {
	while (p) {
	    if (p->cid == cid) {
		if (lp) {
		    p2=p->next;
		    lp->next=p2;
		    if (p->what) free(p->what);
		    free(p);
		    p=p2;
		} else {
		    p2=p->next;
		    modelist=p2;
		    if (p->what) free(p->what);
		    free(p);
		    p=p2;
		}
	    } else {
		if (lp) lp=lp->next; else if (modelist != p2) lp=modelist;
		p=p->next;
	    }
	}
    }
}

int flushchanmode(int cid) {
    struct smode *p;
    char modlist[32];
    char whatlist[512];
    char modlist2[32];
    char whatlist2[512];
    char pm=0;
    int i, ret;
    int eIcnt=0;
    int noteIcnt=0;
    int parcnt=0;
    int modecnt=0;
    int ok=0;
    if (chantab[cid].cjoin) if ((chantab[cid].conchan-chantab[cid].copped) < 3) return 0;
    ret=findfreecloneuserflagschanidpenalty(cid, USER_OP);
    if (ret == (-1)) return 0;
    if (ret == (-2)) {
	return 0;
    }
    strcpy(whatlist, "");
    strcpy(modlist, "");
    i=0;
    p=modelist;
    while (p) {
	if ((p->cid == cid) && (p->cloneid == (-1))) {
	    if ((noteIcnt == 0) && ((p->mode == 'e') || (p->mode == 'I'))) {
		eIcnt++;
		p->cloneid=ret;
		if (pm != p->pm) {
		    pm=p->pm;
		    modlist[strlen(modlist)+1]=0;
		    modlist[strlen(modlist)]=pm;
		}
		modlist[strlen(modlist)+1]=0;
		modlist[strlen(modlist)]=p->mode;
		strcat(whatlist, p->what);
		strcat(whatlist, " ");
		parcnt++;
		modecnt++;
	    } else if (eIcnt == 0) {
		noteIcnt++;
		p->cloneid=ret;
		if (pm != p->pm) {
		    pm=p->pm;
		    modlist[strlen(modlist)+1]=0;
		    modlist[strlen(modlist)]=pm;
		}
		modlist[strlen(modlist)+1]=0;
		modlist[strlen(modlist)]=p->mode;
		if (p->what) {
		    strcat(whatlist, p->what);
		    strcat(whatlist, " ");
		    parcnt++;
		}
		modecnt++;
	    }
	    if (parcnt == 3) {
		whatlist[strlen(whatlist)-1]=0;
		dprintf(socktab[clonetab[ret].sid].fd, "MODE %s %s %s\n", chantab[cid].name, modlist, whatlist);
		clonetab[ret].penalty+=1+3*modecnt;
		ok=1;
		strcpy(whatlist, "");
		strcpy(modlist, "");
		parcnt=0; modecnt=0; eIcnt=0; noteIcnt=0; pm=0;
		ret=findfreecloneuserflagschanidpenalty(cid, USER_OP);
		if (ret == -1) return 0;
	    }
	}
	p=p->next;
    }
    if (modecnt) {
	if (parcnt && whatlist[0]) {
	    whatlist[strlen(whatlist)-1]=0;
	    dprintf(socktab[clonetab[ret].sid].fd, "MODE %s %s %s\n", chantab[cid].name, modlist, whatlist);
	    clonetab[ret].penalty+=1+3*modecnt;
	    ok=1;
	} else {
    	    dprintf(socktab[clonetab[ret].sid].fd, "MODE %s %s\n", chantab[cid].name, modlist);
	    clonetab[ret].penalty+=1+3*modecnt;
	    ok=1;
	}
    }
    return ok;
}

int resendchanmodeid(int cid, int cloneid) {
    struct smode *p;
    p=modelist;
    while (p) {
	if ((p->cid == cid) && (p->cloneid == cloneid)) p->cloneid=(-1);
	p=p->next;
    }
}

int flushmode() {
    register int i;
    for (i=0; i < MAXCHANNELS; i++) if (!(chantab[i].flags & CHAN_UNUSED)) while (flushchanmode(i)) {};
}

int addchaninviteid(int cid, char *nick) {
    struct sinvite *p;
    if (chantab[cid].flags & CHAN_UNUSED) return 0;
    if (!nick) return 0;
    if (!nick[0] || (strlen(nick) > 9)) return 0;
    p=invitelist;
    while (p) {
	if (p->cid == cid) if (strcasecmp(p->nick, nick) == 0) return 1;
	p=p->next;
    }
    p=(struct sinvite *) malloc(sizeof(struct sinvite));
    p->cid=cid;
    p->cloneid=(-1);
    strcpy(p->nick, nick);
    p->next=invitelist;
    invitelist=p;
    return 1;
}

int delchaninviteid(int cid, char *nick) {
    struct sinvite *p, *p2, *lp;
    if (chantab[cid].flags & CHAN_UNUSED) return 0;
    if (!nick) return 0;
    if (!nick[0] || (strlen(nick) > 9)) return 0;
    p=invitelist;
    lp=NULL;
    if (nick[0] != '*') {
	while (p) {
	    if (p->cid == cid) if (strcasecmp(p->nick, nick) == 0) {
		if (lp) {
		    lp->next=p->next;
		    free(p);
		} else {
		    invitelist=p->next;
		    free(p);
		}
		return 1;
	    }
	    if (lp) lp=lp->next; else lp=invitelist;
	    p=p->next;
	}
    } else {
	while (p) {
	    if (p->cid == cid) {
		if (lp) {
		    p2=p->next;
		    lp->next=p2;
		    free(p);
		    p=p2;
		} else {
		    p2=p->next;
		    invitelist=p2;
		    free(p);
		    p=p2;
		}
	    } else {
		if (lp) lp=lp->next; else if (invitelist != p2) lp=invitelist;
		p=p->next;
	    }
	}
    }
    return 0;
}

int flushchaninviteid(int cid) {
    struct sinvite *p;
    int ret;
    if (chantab[cid].flags & CHAN_UNUSED) return 0;
    ret=findfreecloneuserflagschanidpenalty(cid, USER_OP);
    if (ret == (-1)) return 0;
    if (ret == (-2)) return 0;
    p=invitelist;
    while (p) {
	if ((p->cid == cid) && (p->cloneid == (-1))) {
	    p->cloneid=ret;
	    dprintf(socktab[clonetab[ret].sid].fd, "INVITE %s %s\n", p->nick, chantab[cid].name);
	    clonetab[ret].penalty+=2;
	    ret=findfreecloneuserflagschanidpenalty(cid, USER_OP);
	    if (ret == -1) return 0;
	}
	p=p->next;
    }
    return 1;
}

int resendchaninviteid(int cid, int cloneid) {
    struct sinvite *p;
    p=invitelist;
    while (p) {
	if ((p->cid == cid) && (p->cloneid == cloneid)) p->cloneid=(-1);
	p=p->next;
    }
}

int flushinvite() {
    register int i;
    for (i=0; i < MAXCHANNELS; i++) if (!(chantab[i].flags & CHAN_UNUSED)) flushchaninviteid(i);
}

int addmasklist(struct smasklist **list, char *mask) {
    struct smasklist *p;
    if (!list) return 0;
    if (!mask) return 0;
    if (!mask[0]) return 0;
    if (strlen(mask) >= MAXMASKLEN) return 0;
    p=*list;
    while (p) {
	if (strcasecmp(p->mask, mask) == 0) return 0;
	p=p->next;
    }
    p=(struct smasklist *) malloc (sizeof(struct smasklist));
    p->mask=(char *) malloc(strlen(mask)+1);
    strcpy(p->mask, mask);
    if (*list == NULL) {
	*list=p;
	p->next=NULL;
    } else {
	p->next=*list;
	*list=p;
    }
    return 1;
}

int delmasklist(struct smasklist **list, char *mask) {
    struct smasklist *p, *lp;
    if (!list) return 0;
    if (!mask) return 0;
    if (!mask[0]) return 0;
    if (strlen(mask) >= MAXMASKLEN) return 0;
    lp=NULL;
    p=*list;
    while (p) {
	if (strcasecmp(p->mask, mask) == 0) {
	    if (lp) {
		lp->next=p->next;
		if (p->mask) free(p->mask);
		free(p);
	    } else {
		*list=p->next;
		if (p->mask) free(p->mask);
		free(p);
	    }
	    return 1;
	}
	lp=p;
	p=p->next;
    }
    return 0;
}

int matchmasklist(struct smasklist **list, char *mask) {
    struct smasklist *p, *lp;
    if (!list) return 0;
    if (!mask) return 0;
    if (!mask[0]) return 0;
    if (strlen(mask) >= MAXMASKLEN) return 0;
    p=*list;
    while (p) {
	if (matchmask(mask, p->mask)) return 1;
	p=p->next;
    }
    return 0;
}

int freemasklist(struct smasklist **list) {
    struct smasklist *p, *lp;
    if (!list) return 0;
    p=*list;
    while (p) {
	lp=p;
	p=p->next;
	if (lp->mask) free(lp->mask);
	free(lp);
    }
    *list=NULL;
    return 1;
}
