#define RECONNECTTIME			10
#define REJOINTIME			20

void docsettings(int setid, int chanid, char *nick, char *victim, char mode) {
    struct suser *p;
    if (!chantab[chanid].conchan || !chantab[chanid].copped) return;
    if (chantab[chanid].csettings[setid] & CS_DEOP) addchanmodeid(chanid, '-', 'o', nick);
    if (chantab[chanid].csettings[setid] & CS_DEOPVICTIM) addchanmodeid(chanid, '-', 'o', victim);
    if (chantab[chanid].csettings[setid] & CS_KICK) addchankickid(chanid, nick);
    if (chantab[chanid].csettings[setid] & CS_KICKVICTIM) addchankickid(chanid, victim);
    if (chantab[chanid].csettings[setid] & CS_REMOVE) addchanmodeid(chanid, '-', mode, victim);
    if (chantab[chanid].csettings[setid] & CS_SET_I) addchanmodeid(chanid, '+', 'i', "");
    if (chantab[chanid].csettings[setid] & CS_SET_K) addchanmodeid(chanid, '+', 'k', "DkE");
    if (chantab[chanid].csettings[setid] & CS_MASSDEOP) {
	p=chantab[chanid].usersfirst;
	while (p) {
	    if (p->flags & USER_OP) if (!isclonenick(p->nick) && !ULMATCHFLAG(p->handle, 'm')) addchanmodeid(chanid, '-', 'o', p->nick);
	    p=p->next;
	}
    }
    if (chantab[chanid].csettings[setid] & CS_MASSKICKOP) {
	p=chantab[chanid].usersfirst;
	while (p) {
	    if (p->flags & USER_OP) if (!isclonenick(p->nick) && !ULMATCHFLAG(p->handle, 'm')) addchankickid(chanid, p->nick);
	    p=p->next;
	}
    }
    if (chantab[chanid].csettings[setid] & CS_MASSKICKALL) {
	p=chantab[chanid].usersfirst;
	while (p) {
	    if (!isclonenick(p->nick) && !ULMATCHFLAG(p->handle, 'm')) addchankickid(chanid, p->nick);
	    p=p->next;
	}
    }
}

void clone_parse(char *s, struct ssock *sock) {
    struct sclonespecial *p;
    char *par[8];
    if (!s) return;
    if (!s[0]) return;
    if (!sock) return;
    p=(struct sclonespecial *) sock->special;
    if (!p) return;
    par[0]=newsplit(&s);
    if (!par[0][0]) return;
    if (par[0][0] == ':') {
	par[0]++;
	par[1]=newsplit(&s);
        call(CALL_IRC, par[1])(sock, p, par[0], s);
    } else {
        call(CALL_IRC, par[0])(sock, p, NULL, s);
    }
}
				
void clone_onconnect(struct ssock *sock) {
    struct sclonespecial *p;
    p=(struct sclonespecial *) sock->special;
    if (!p) return;
    if (clonetab[p->cid].status != CLONE_CONNECT) return;
    clonesstats.connect--;
    clonesstats.connected++;
    clonetab[p->cid].status=CLONE_CONNECTED;
    dprintf(sock->fd, "NICK %s\nUSER %s 8 * :%s\n", clonetab[p->cid].nick, clonetab[p->cid].nick, cname);
}

void clone_ondisconnect(struct ssock *sock) {
    struct sclonespecial *p;
    struct suser *user;
    int i, cid;
    char *nick;
    p=(struct sclonespecial *) sock->special;
    if (!p) return;
    switch (clonetab[p->cid].status) {
    case CLONE_CONNECTED:
	clonesstats.connected--;
	clonesstats.connect++;
	break;
    case CLONE_REGISTERED:
	clonesstats.registered--;
	clonesstats.connect++;
    };
    clonetab[p->cid].status=CLONE_DISCONNECTED;
    clonetab[p->cid].time=now+RECONNECTTIME;
    for (i=0; i < MAXCHANNELS; i++) if (!(chantab[i].flags & CHAN_UNUSED)) {
	if (!(clonetab[p->cid].channels[i].flags & CLONE_CHAN_ONCHAN)) break;
	clonetab[p->cid].channels[i].flags&=~CLONE_CHAN_ONCHAN;
	chantab[i].conchan--;
	chantab[i].onchan--;
	if (isopchannickid(i, clonetab[p->cid].nick)) {
	    chantab[i].copped--;
	    chantab[i].opped--;
	}
	if (chantab[i].copped) {
	    resendchankickid(i, cid);
	    resendchanmodeid(i, cid);
	    resendchaninviteid(i, cid);
	    delchanmodeid(i, '*', '*', nick);
	} else {
	    chantab[i].cflags|=CHAN_C_AFTEROP;
	    delchankickid(i, "*");
	    delchanmodeid(i, '*', '*', NULL);
	    delchaninviteid(i, "*");
	}
	if (!chantab[i].conchan) chantab[i].cmdcount=0;
	if ((clonetab[p->cid].channels[i].flags & CLONE_CHAN_SENTWHO) && (chantab[i].flags & CHAN_SENTWHO)) {
	    clonetab[p->cid].channels[i].flags&=~CLONE_CHAN_SENTWHO;
	    chantab[i].flags&=~CHAN_SENTWHO;
	    clonessendchanwhoid(i);
	}
	if (((clonetab[p->cid].channels[i].flags & CLONE_CHAN_SENTMODE) && (chantab[i].flags & CHAN_SENTMODE)) ||
    	    ((clonetab[p->cid].channels[i].flags & CLONE_CHAN_SENTBANLIST) && (chantab[i].flags & CHAN_SENTBANLIST)) ||
	    ((clonetab[p->cid].channels[i].flags & CLONE_CHAN_SENTEXEMPTLIST) && (chantab[i].flags & CHAN_SENTEXEMPTLIST)) ||
    	    ((clonetab[p->cid].channels[i].flags & CLONE_CHAN_SENTINVITELIST) && (chantab[i].flags & CHAN_SENTINVITELIST))) {
	    clonetab[p->cid].channels[i].flags&=~CLONE_CHAN_SENTMODE;
	    chantab[i].flags&=~CHAN_SENTMODE;
	    clonetab[p->cid].channels[i].flags&=~CLONE_CHAN_SENTBANLIST;
	    chantab[i].flags&=~CHAN_SENTBANLIST;
	    clonetab[p->cid].channels[i].flags&=~CLONE_CHAN_SENTEXEMPTLIST;
	    chantab[i].flags&=~CHAN_SENTEXEMPTLIST;
	    clonetab[p->cid].channels[i].flags&=~CLONE_CHAN_SENTINVITELIST;
	    chantab[i].flags&=~CHAN_SENTINVITELIST;
	    clonessendchanmodebeiid(i);
	}
	delchanmodeid(i, '*', '*', clonetab[p->cid].nick);
	delchankickid(i, clonetab[p->cid].nick);
	delchaninviteid(i, clonetab[p->cid].nick);
	delchanuserid(i, clonetab[p->cid].nick);
    }
    for (i=0; i < MAXCHANNELS; i++) {
        clonetab[p->cid].channels[i].flags=0;
        clonetab[p->cid].channels[i].join=0;
        clonetab[p->cid].channels[i].cmdcount=0;
    }
    return;
}

void clone_onrecv(struct ssock *sock) {
    struct sclonespecial *p;
    p=(struct sclonespecial *) sock->special;
    if (!p) return;
    if ((clonetab[p->cid].status != CLONE_CONNECTED) && (clonetab[p->cid].status != CLONE_REGISTERED)) return;
    if (!sock) return;
    if (!sock->inbuf) return;
    parse(sock->inbuf, '\n', clone_parse, sock);
}

void clone_onclose(struct ssock *sock) {
    struct sclonespecial *p;
    p=(struct sclonespecial *) sock->special;
    if (!p) return;
    free(p);
}

void clone_onerror(struct ssock *sock) {
    struct sclonespecial *p;
    p=(struct sclonespecial *) sock->special;
    if (!p) return;
}

int setserver(int ipv6, char *raddr, int rport) {
    if ((strlen(raddr) == 0) || (strlen(raddr) > 127)) return 0;
    strcpy(clonesserv, raddr);
    clonesport=rport;
    clonesservipv6=ipv6;
    return 1;
}

int isclonenick(char *nick) {
    register int i;
    if (!nick) return 0;
    if (!nick[0] || (strlen(nick) > 9)) return 0;
    for (i=0; i < MAXCLONES; i++) if (clonetab[i].status == CLONE_REGISTERED)
	if (strcasecmp(clonetab[i].nick, nick) == 0) return 1;
    return 0;
}

int getclonenick(char *nick) {
    register int i;
    if (!nick) return (-1);
    if (!nick[0] || (strlen(nick) > 9)) return (-1);
    for (i=0; i < MAXCLONES; i++) if (clonetab[i].status == CLONE_REGISTERED)
	if (strcasecmp(clonetab[i].nick, nick) == 0) return i;
    return (-1);
}

int addclone(char *nick, char *vhost) {
    struct sclonespecial *p;
    int i, j, sid, ret;
    if (!nick) return (-1);
    if (!nick[0] || (strlen(nick) > 9)) return (-1);
    for (i=0; i < MAXCLONES; i++) if (clonetab[i].status == CLONE_FREE) {
	strcpy(clonetab[i].nick, nick);
	if (clonesservipv6) ret=socket_create(SOCKTYPE_NORMAL6, 0, clone_onconnect, clone_ondisconnect, clone_onrecv, clone_onclose, clone_onerror);
	    else ret=socket_create(SOCKTYPE_NORMAL, 0, clone_onconnect, clone_ondisconnect, clone_onrecv, clone_onclose, clone_onerror);
	if (ret < 0) {
	    ERROR0("addclone: Create socket error.");
	    return (-1);
	}
	sid=ret;
	socktab[sid].special=NULL;
	if (vhost) {
	    ret=socket_bind(sid, vhost, 0);
	    if (!ret) {
		ERROR0("addclone: Bind error.");
	    }
	}
	ret=socket_connect(sid, clonesserv, clonesport);
	if (!ret) {
	    ERROR0("addclone: Connect error.");
	    socket_closeid(sid);
	    return (-1);
	}
	clonetab[i].time=0;
	clonetab[i].status=CLONE_CONNECT;
	clonetab[i].penalty=0;
	clonetab[i].sid=sid;
	p=(struct sclonespecial *) malloc(sizeof(struct sclonespecial));
	p->cid=i;
	socktab[sid].special=(void *) p;
	for (j=0; j < MAXCHANNELS; j++) {
	    clonetab[i].channels[j].flags=0;
	    clonetab[i].channels[j].join=0;
	    clonetab[i].channels[j].cmdcount=0;
	}
	clonesstats.connect++;
	return i;
    }
    return (-1);
}

int delcloneid(int id) {
    int i;
    switch (clonetab[id].status) {
    case CLONE_CONNECT:
	socket_closeid(clonetab[id].sid);
	clonesstats.connect--;
	break;
    case CLONE_CONNECTED:
	socket_closeid(clonetab[id].sid);
	clonesstats.connected--;
	break;
    case CLONE_REGISTERED:
	dprintf(socktab[clonetab[id].sid].fd, "QUIT :%s\n", cname);
	socket_closeid(clonetab[id].sid);
	clonesstats.registered--;
	break;
    case CLONE_DISCONNECTED:
	clonesstats.connect--;
	break;
    }		
    clonetab[id].status=CLONE_FREE;
    for (i=0; i < MAXCHANNELS; i++) if (!(chantab[i].flags & CHAN_UNUSED)) {
	if (!(clonetab[id].channels[i].flags & CLONE_CHAN_ONCHAN)) break;
	clonetab[id].channels[i].flags&=~CLONE_CHAN_ONCHAN;
	chantab[i].conchan--;
	chantab[i].onchan--;
	if (isopchannickid(i, clonetab[id].nick)) {
	    chantab[i].copped--;
	    chantab[i].opped--;
	}
	if (chantab[i].copped) {
	    resendchankickid(i, id);
	    resendchanmodeid(i, id);
	    resendchaninviteid(i, id);
	    delchanmodeid(i, '*', '*', clonetab[id].nick);
	} else {
	    chantab[i].cflags|=CHAN_C_AFTEROP;
	    delchankickid(i, "*");
	    delchanmodeid(i, '*', '*', NULL);
	    delchaninviteid(i, "*");
	}
	if (!chantab[i].conchan) chantab[i].cmdcount=0;
	if ((clonetab[id].channels[i].flags & CLONE_CHAN_SENTWHO) && (chantab[i].flags & CHAN_SENTWHO)) {
	    clonetab[id].channels[i].flags&=~CLONE_CHAN_SENTWHO;
	    chantab[i].flags&=~CHAN_SENTWHO;
	    clonessendchanwhoid(i);
	}
	if (((clonetab[id].channels[i].flags & CLONE_CHAN_SENTMODE) && (chantab[i].flags & CHAN_SENTMODE)) ||
    	    ((clonetab[id].channels[i].flags & CLONE_CHAN_SENTBANLIST) && (chantab[i].flags & CHAN_SENTBANLIST)) ||
	    ((clonetab[id].channels[i].flags & CLONE_CHAN_SENTEXEMPTLIST) && (chantab[i].flags & CHAN_SENTEXEMPTLIST)) ||
    	    ((clonetab[id].channels[i].flags & CLONE_CHAN_SENTINVITELIST) && (chantab[i].flags & CHAN_SENTINVITELIST))) {
	    clonetab[id].channels[i].flags&=~CLONE_CHAN_SENTMODE;
	    chantab[i].flags&=~CHAN_SENTMODE;
	    clonetab[id].channels[i].flags&=~CLONE_CHAN_SENTBANLIST;
	    chantab[i].flags&=~CHAN_SENTBANLIST;
	    clonetab[id].channels[i].flags&=~CLONE_CHAN_SENTEXEMPTLIST;
	    chantab[i].flags&=~CHAN_SENTEXEMPTLIST;
	    clonetab[id].channels[i].flags&=~CLONE_CHAN_SENTINVITELIST;
	    chantab[i].flags&=~CHAN_SENTINVITELIST;
	    clonessendchanmodebeiid(i);
	}
	delchanmodeid(i, '*', '*', clonetab[id].nick);
	delchankickid(i, clonetab[id].nick);
	delchaninviteid(i, clonetab[id].nick);
	delchanuserid(i, clonetab[id].nick);
    }
    for (i=0; i < MAXCHANNELS; i++) {
        clonetab[id].channels[i].flags=0;
        clonetab[id].channels[i].join=0;
        clonetab[id].channels[i].cmdcount=0;
    }
    return 1;
}

int delclonename(char *nick) {
    int i;
    if (!nick) return 0;
    if (!nick[0] || (strlen(nick) > 9)) return 0;
    for (i=0; i < MAXCLONES; i++) if (clonetab[i].status != CLONE_FREE)
	if (strcasecmp(clonetab[i].nick, nick) == 0) return delcloneid(i);
    return 0;
}

int findfreeclone() {
    register int i, min;
    int cid=(-1);
    min=0xffff;
    for (i=0; i < MAXCLONES; i++)
	if (clonetab[i].status == CLONE_REGISTERED) 
	    if (clonetab[i].penalty < min) {
		min=clonetab[i].penalty;
		cid=i;
	    }
    return cid;
}

int findfreeclonepenalty() {
    register int i, min;
    int cid=(-1);

    min=10;
    for (i=0; i < MAXCLONES; i++)
	if (clonetab[i].status == CLONE_REGISTERED) 
	    if (clonetab[i].penalty < min) {
		min=clonetab[i].penalty;
		cid=i;
	    }
    return cid;
}

// (-2)  No clones matching that flag or no such channel
// (-1)  All clones has penalty
int findfreecloneuserflagschanidpenalty(int chanid, int flags) {
    register int i, min;
    int cid=(-2);

    if (chantab[chanid].flags & CHAN_UNUSED) return (-2);
    min=10;
    for (i=0; i < MAXCLONES; i++)
	if (clonetab[i].status == CLONE_REGISTERED) 
	    if (matchflagschanuserid(chanid, clonetab[i].nick, flags)) {
		if (cid == (-2)) cid=(-1);
		if (clonetab[i].penalty < min) {
		    min=clonetab[i].penalty;
		    cid=i;
		}
	    }
    return cid;
}

// (-2)  No clones matching that flag or no such channel
// (-1)  All clones has penalty
int findfreeclonecflagschanidpenalty(int chanid, int flags) {
    register int i, min;
    int cid=(-2);

    if (chantab[chanid].flags & CHAN_UNUSED) return (-2);
    min=10;
    for (i=0; i < MAXCLONES; i++)
	if (clonetab[i].status == CLONE_REGISTERED) 
	    if (clonetab[i].channels[chanid].flags & flags) {
		if (cid == (-2)) cid=(-1);
		if (clonetab[i].penalty < min) {
		    min=clonetab[i].penalty;
		    cid=i;
		}
	    }
    return cid;
}

void sendjoin(int i, int cid) {
    chantab[cid].cjoin++;
    if (clonetab[i].channels[cid].flags & CLONE_CHAN_UNJOIN) chantab[cid].cunjoin--;
    clonetab[i].channels[cid].join=0;
    clonetab[i].channels[cid].flags=CLONE_CHAN_SENTJOIN;
    clonetab[i].channels[cid].flags|=CLONE_CHAN_SENTNAMES;
    clonetab[i].channels[cid].cmdcount=0;
    clonetab[i].channels[cid].synccid=(-1);
    if (chantab[cid].key) dprintf(socktab[clonetab[i].sid].fd, "JOIN %s :%s\n", chantab[cid].name, chantab[cid].key);
	else dprintf(socktab[clonetab[i].sid].fd, "JOIN %s\n", chantab[cid].name);
    clonetab[i].penalty+=2;
}

int clonejoinchanid(int i, int cid) {
    int ok;
    char limit[16];
    if (cid >= MAXCHANNELS) return 0;
    if ((clonetab[i].status == CLONE_REGISTERED) && (chantab[cid].flags & CHAN_JOIN) && !(clonetab[i].channels[cid].flags & CLONE_CHAN_SENTJOIN) && !(clonetab[i].channels[cid].flags & CLONE_CHAN_ONCHAN) && !(clonetab[i].channels[cid].flags & CLONE_CHAN_SELFJOIN) && (clonetab[i].penalty <= MAXPENALTY)) {
	if (clonetab[i].channels[cid].flags & CLONE_CHAN_UNJOIN) {
	    if (chantab[cid].conchan) {
		ok=1;
		if (clonetab[i].channels[cid].flags & CLONE_CHAN_NEEDLIMIT)
		    if ((chantab[cid].mode & MODE_L) && (chantab[cid].limit <= chantab[cid].onchan)) ok=0;
		if (clonetab[i].channels[cid].flags & CLONE_CHAN_NEEDINVITE)
		    if ((chantab[cid].mode & MODE_I)) ok=0;
		if (clonetab[i].channels[cid].flags & CLONE_CHAN_BANNED)
		    ok=0;
		if (ok) sendjoin(i, cid);
		if (!ok && chantab[cid].copped) {
		    if (clonetab[i].channels[cid].flags & CLONE_CHAN_NEEDLIMIT) {
			sprintf(limit, "%d", chantab[cid].onchan+chantab[cid].cjoin+chantab[cid].cunjoin+10);
			addchanmodeid(cid, '+', 'l', limit);
		    }
		    if (clonetab[i].channels[cid].flags & CLONE_CHAN_NEEDINVITE) {
			addchaninviteid(cid, clonetab[i].nick);
		    }
		    if (clonetab[i].channels[cid].flags & CLONE_CHAN_BANNED) {
			addchaninviteid(cid, clonetab[i].nick);
		    }
		} else if (!ok) {
		    ok=1;
		    if (clonetab[i].channels[cid].flags & CLONE_CHAN_NEEDLIMIT)
			if ((chantab[cid].mode & MODE_L) && (chantab[cid].limit <= chantab[cid].onchan)) ok=0;
		    if (clonetab[i].channels[cid].flags & CLONE_CHAN_NEEDINVITE)
			if ((chantab[cid].mode & MODE_I)) ok=0;
		    if (clonetab[i].channels[cid].flags & CLONE_CHAN_BANNED)
			ok=0;
		    if (ok) sendjoin(i, cid);
		}
	    } else {
		if (!clonetab[i].channels[cid].join) clonetab[i].channels[cid].join=now+REJOINTIME;
		if (clonetab[i].channels[cid].join && (clonetab[i].channels[cid].join < now)) {
		    sendjoin(i, cid);
		}
	    }
	} else {
	    sendjoin(i, cid);
	}
    }
}

int clonejoinchanname(int i, char *name) {
    int cid;
    if (clonetab[i].status != CLONE_REGISTERED) return 0;
    cid=findchanname(name);
    if (cid < 0) return 0;
    return clonejoinchanid(i, cid);
}

int clonesjoinchanid(int cid) {
    int i;
    if (cid >= MAXCHANNELS) return 0;
    if ((chantab[cid].flags & CHAN_UNUSED) || !(chantab[cid].flags & CHAN_JOIN)) return 0;
    for (i=0; i < MAXCLONES; i++)
	if ((clonetab[i].status == CLONE_REGISTERED) && !(clonetab[i].channels[cid].flags & CLONE_CHAN_SENTJOIN) && !(clonetab[i].channels[cid].flags & CLONE_CHAN_ONCHAN) && (clonetab[i].penalty <= MAXPENALTY)) 
	    clonejoinchanid(i, cid);
}

int clonesjoinchanname(char *name) {
    int cid;
    if (!clonesstats.registered) return 0;
    cid=findchanname(name);
    if (cid < 0) return 0;
    return clonesjoinchanid(cid);
}

int clonespartchanid(int cid) {
    int i;
    if (cid >= MAXCHANNELS) return 0;
    for (i=0; i < MAXCLONES; i++) {
	if ((clonetab[i].status == CLONE_REGISTERED) && (clonetab[i].channels[cid].flags & CLONE_CHAN_ONCHAN)) {
	    dprintf(socktab[clonetab[i].sid].fd, "PART %s\n", chantab[cid].name);
	    clonetab[i].penalty+=3;
	}
	clonetab[i].channels[cid].flags=0;
	clonetab[i].channels[cid].synccid=(-1);
	clonetab[i].channels[cid].cmdcount=0;
    }
}

int clonespartchanname(char *name) {
    int cid;
    if (!clonesstats.registered) return 0;
    cid=findchanname(name);
    if (cid < 0) return 0;
    return clonespartchanid(cid);
}

int clonessendchanmodebeiid(int cid) {
    int ret;
    if (cid >= MAXCHANNELS) return 0;
    if (chantab[cid].flags & CHAN_UNUSED) return 0;
    if (!chantab[cid].conchan) return 0;
    if (!(chantab[cid].flags & CHAN_SENTMODE) && !(chantab[cid].flags & CHAN_GOTMODE)) {
	ret=findfreeclonecflagschanidpenalty(cid, CLONE_CHAN_ONCHAN);
	if (ret < 0) return 0;
	printf("(%s) Sending MODE %s\n", clonetab[ret].nick, chantab[cid].name);
	chantab[cid].flags|=CHAN_SENTMODE;
	clonetab[ret].channels[cid].flags|=CLONE_CHAN_SENTMODE;
	dprintf(socktab[clonetab[ret].sid].fd, "MODE %s\n", chantab[cid].name);
	clonetab[ret].penalty+=2;
    }
    if (!(chantab[cid].flags & CHAN_SENTBANLIST) && !(chantab[cid].flags & CHAN_GOTBANLIST)) {
	ret=findfreeclonecflagschanidpenalty(cid, CLONE_CHAN_ONCHAN);
	if (ret < 0) return 0;
	printf("(%s) Sending MODE +b %s\n", clonetab[ret].nick, chantab[cid].name);
	chantab[cid].flags|=CHAN_SENTBANLIST;
	clonetab[ret].channels[cid].flags|=CLONE_CHAN_SENTBANLIST;
	dprintf(socktab[clonetab[ret].sid].fd, "MODE +b %s\n", chantab[cid].name);
	clonetab[ret].penalty+=2;
    }
    if (!(chantab[cid].flags & CHAN_SENTEXEMPTLIST) && !(chantab[cid].flags & CHAN_GOTEXEMPTLIST)) {
	ret=findfreeclonecflagschanidpenalty(cid, CLONE_CHAN_ONCHAN);
	if (ret < 0) return 0;
	printf("(%s) Sending MODE +e %s\n", clonetab[ret].nick, chantab[cid].name);
	chantab[cid].flags|=CHAN_SENTEXEMPTLIST;
	clonetab[ret].channels[cid].flags|=CLONE_CHAN_SENTEXEMPTLIST;
	dprintf(socktab[clonetab[ret].sid].fd, "MODE +e %s\n", chantab[cid].name);
	clonetab[ret].penalty+=2;
    }
    if (!(chantab[cid].flags & CHAN_SENTINVITELIST) && !(chantab[cid].flags & CHAN_GOTINVITELIST)) {
	ret=findfreeclonecflagschanidpenalty(cid, CLONE_CHAN_ONCHAN);
	if (ret < 0) return 0;
	printf("(%s) Sending MODE +I %s\n", clonetab[ret].nick, chantab[cid].name);
	chantab[cid].flags|=CHAN_SENTINVITELIST;
	clonetab[ret].channels[cid].flags|=CLONE_CHAN_SENTINVITELIST;
	dprintf(socktab[clonetab[ret].sid].fd, "MODE +I %s\n", chantab[cid].name);
	clonetab[ret].penalty+=2;
    }
    return 1;
}

int clonessendchanmodebeiname(char *name) {
    register int i;
    int cid;
    if (clonesstats.registered == 0) return 0;
    cid=findchanname(name);
    if (cid < 0) return 0;
    return clonessendchanmodebeiid(cid);
}

int clonessendchanwhoid(int cid) {
    int ret;
    if (cid >= MAXCHANNELS) return 0;
    if (chantab[cid].flags & CHAN_UNUSED) return 0;
    if (!chantab[cid].conchan) return 0;
    if (!(chantab[cid].flags & CHAN_SENTWHO) && !(chantab[cid].flags & CHAN_GOTWHO)) {
	ret=findfreeclonecflagschanidpenalty(cid, CLONE_CHAN_ONCHAN);
	if (ret < 0) return 0;
	printf("(%s) Sending WHO %s\n", clonetab[ret].nick, chantab[cid].name);
	chantab[cid].flags|=CHAN_SENTWHO;
	clonetab[ret].channels[cid].flags|=CLONE_CHAN_SENTWHO;
	dprintf(socktab[clonetab[ret].sid].fd, "WHO %s\n", chantab[cid].name);
	clonetab[ret].penalty+=2;
    }
    return 1;
}

void gotwelcome(int cid, int sid, int sock) {
    int i;
    for (i=0; i < MAXCHANNELS; i++) if (clonetab[i].status == CLONE_REGISTERED) 
	clonejoinchanid(cid, i);
}

void gotop1(int chanid, char *nick, char *host, char *who) {
    struct suser *user;
    if (chantab[chanid].flags & CHAN_UNUSED) return;
    if (!nick) return;
    if (!nick[0] || (strlen(nick) > 9)) return;
    if (!who) return;
    if (!who[0] || (strlen(who) > 9)) return;
    if (!host) return;
    if (!host[0]) return;
    user=findchanuserid(chanid, who);
    if (user) {
	user->flags|=USER_OP;
//	if (user->handle == NULL) user->handle=ulfindhandlehost(user->host);
    }
    delchanmodeid(chanid, '+', 'o', who);
}

void gotop2(int chanid, char *nick, char *host, char *who) {
    struct suser *opper, *opped;
    int i, sj;
    if (chantab[chanid].flags & CHAN_UNUSED) return;
    if (!nick) return;
    if (!nick[0] || (strlen(nick) > 9)) return;
    if (!who) return;
    if (!who[0] || (strlen(who) > 9)) return;
    if (!host) return;
    if (!host[0]) return;
//    if (isserver(nick)) docsettings(C_SERVERMODE, chanid, nick, who, ' ');
    if (!nick[0] || (strlen(nick) > 9)) return;
    opper=findchanuserid(chanid, nick);
    opped=findchanuserid(chanid, who);
    if (opper == NULL) return;
    if (opped == NULL) {
	if (!isclonenick(nick) && !isclonenick(who)) {
	    addchankickid(chanid, who);
	    addchankickid(chanid, nick);
	    opper->flags=USER_SENTKICK;
	    printf("opped == NULL\n");
	}
	return;
    }
    if (!(opped->flags & USER_OP)) return;
    if (opped->flags & USER_HASOP) return;
    opped->flags|=USER_HASOP;
    printf("User %s sets mode +o %s on %s.\n", nick, who, chantab[chanid].name);
    chantab[chanid].opped++;
    sj=0;
    if (isclonenick(who)) {
	for (i=0; i < MAXCLONES; i++) if (clonetab[i].status == CLONE_REGISTERED) {
	    if (clonetab[i].channels[chanid].flags & CLONE_CHAN_ONCHAN) if (!isopchannickid(chanid, clonetab[i].nick)) addchanmodeid(chanid, '+', 'o', clonetab[i].nick);
	    if (chantab[chanid].flags & CHAN_JOIN) if (clonetab[i].channels[chanid].flags & CLONE_CHAN_UNJOIN) sj=1;
	}
	chantab[chanid].copped++;
	if (chantab[chanid].conchan == chantab[chanid].copped) if (chantab[chanid].cflags & CHAN_C_AFTEROP) {
	    docsettings(C_AFTEROP, chanid, nick, who, ' ');
	    chantab[chanid].cflags&=~CHAN_C_AFTEROP;
	}
	if (sj) clonesjoinchanid(chanid);
    } else if (isclonenick(nick)) {
    } else {
	if (chantab[chanid].copped && !ULMATCHFLAG(opped->handle, 'o') && !ULMATCHFLAG(opper->handle, 'm')) docsettings(C_BITCH, chanid, nick, who, ' ');
    }
}

void gotdeop1(int chanid, char *nick, char *host, char *who) {
    struct suser *user;
    if (chantab[chanid].flags & CHAN_UNUSED) return;
    if (!nick) return;
    if (!nick[0] || (strlen(nick) > 9)) return;
    if (!who) return;
    if (!who[0] || (strlen(who) > 9)) return;
    if (!host) return;
    if (!host[0]) return;
    user=findchanuserid(chanid, who);
    if (user) {
	user->flags&=~USER_OP;
//	if (user->handle == NULL) user->handle=ulfindhandlehost(host);
    }
    delchanmodeid(chanid, '-', 'o', who);
}

void gotdeop2(int chanid, char *nick, char *host, char *who) {
    struct suser *deopper, *deopped;
    int i, cid;
    if (chantab[chanid].flags & CHAN_UNUSED) return;
    if (!nick) return;
    if (!nick[0] || (strlen(nick) > 9)) return;
    if (!who) return;
    if (!who[0] || (strlen(who) > 9)) return;
    if (!host) return;
    if (!host[0]) return;
    deopper=findchanuserid(chanid, nick);
    deopped=findchanuserid(chanid, who);
    if (deopper == NULL) return;
    if (deopped == NULL) {
	if (!isclonenick(nick) && !isclonenick(who)) {
	    addchankickid(chanid, who);
	    addchankickid(chanid, nick);
	    deopper->flags=USER_SENTKICK;
	    printf("deopped == NULL, %s\n", who);
	}
	return;
    }
    if (deopped->flags & USER_OP) return;
    deopped->flags&=~USER_HASOP;
    printf("User %s sets mode -o %s on %s.\n", nick, who, chantab[chanid].name);
    chantab[chanid].opped--;
    if (isclonenick(who)) {
	cid=getclonenick(who);
	chantab[chanid].copped--;
	if (chantab[chanid].copped) {
	    if (!ULMATCHFLAG(deopper->handle, 'm')) docsettings(C_REVANGE, chanid, nick, who, '*');
	    addchanmodeid(chanid, '+', 'o', who);
	    resendchankickid(chanid, cid);
	    resendchanmodeid(chanid, cid);
	    resendchaninviteid(chanid, cid);
	} else {
	    chantab[chanid].cflags|=CHAN_C_AFTEROP;
	    delchankickid(chanid, "*");
	    delchanmodeid(chanid, '*', '*', NULL);
	    delchaninviteid(chanid, "*");
	}
    } else if (isclonenick(nick)) {
    } else {
        if (chantab[chanid].copped && ULMATCHFLAG(deopped->handle, 'm') && !ULMATCHFLAG(deopper->handle, 'm')) docsettings(C_REVANGE, chanid, nick, who, '*');
    }
}

void gotban(int chanid, char *nick, char *host, char *who) {
    struct suser *user;
    int i;
    if (chantab[chanid].flags & CHAN_UNUSED) return;
    if (!nick) return;
    if (!nick[0] || (strlen(nick) > 9)) return;
    if (!who) return;
    if (!who[0]) return;
    if (!host) return;
    if (!host[0]) return;
    user=findchanuserid(chanid, nick);
    if (user == NULL) {
	if (!isclonenick(nick)) {
	    addchankickid(chanid, nick);
	    user->flags=USER_SENTKICK;
	    printf("ban, user == NULL\n");
	}
	return;
    }
    addmasklist(&chantab[chanid].bans, who);
    delchanmodeid(chanid, '+', 'b', who);
    if (chantab[chanid].copped && !ULMATCHFLAG(user->handle, 'm')) docsettings(C_BAN, chanid, nick, who, 'b');
}

void gotexempt(int chanid, char *nick, char *host, char *who) {
    struct suser *user;
    int i;
    if (chantab[chanid].flags & CHAN_UNUSED) return;
    if (!nick) return;
    if (!nick[0] || (strlen(nick) > 9)) return;
    if (!who) return;
    if (!who[0]) return;
    if (!host) return;
    if (!host[0]) return;
    user=findchanuserid(chanid, nick);
    if (user == NULL) {
	if (!isclonenick(nick)) {
	    addchankickid(chanid, nick);
	    user->flags=USER_SENTKICK;
	    printf("exempt, user == NULL\n");
	}
	return;
    }
    addmasklist(&chantab[chanid].exempts, who);
    if (chantab[chanid].copped && !ULMATCHFLAG(user->handle, 'm')) docsettings(C_EXEMPT, chanid, nick, who, 'e');
    delchanmodeid(chanid, '+', 'e', who);
}

void gotinvite(int chanid, char *nick, char *host, char *who) {
    struct suser *user;
    int i;
    if (chantab[chanid].flags & CHAN_UNUSED) return;
    if (!nick) return;
    if (!nick[0] || (strlen(nick) > 9)) return;
    if (!who) return;
    if (!who[0]) return;
    if (!host) return;
    if (!host[0]) return;
    user=findchanuserid(chanid, nick);
    if (user == NULL) {
	if (!isclonenick(nick)) {
	    addchankickid(chanid, nick);
	    user->flags=USER_SENTKICK;
	    printf("invite, user == NULL\n");
	}
	return;
    }
    addmasklist(&chantab[chanid].invites, who);
    if (chantab[chanid].copped && !ULMATCHFLAG(user->handle, 'm')) docsettings(C_INVITE, chanid, nick, who, 'I');
    delchanmodeid(chanid, '+', 'I', who);
}

void gotunban(int chanid, char *nick, char *host, char *who) {
    struct suser *user;
    int i;
    if (chantab[chanid].flags & CHAN_UNUSED) return;
    if (!nick) return;
    if (!nick[0] || (strlen(nick) > 9)) return;
    if (!who) return;
    if (!who[0]) return;
    if (!host) return;
    if (!host[0]) return;
    user=findchanuserid(chanid, nick);
    if (user == NULL) {
	if (!isclonenick(nick)) {
	    addchankickid(chanid, nick);
	    user->flags=USER_SENTKICK;
	    printf("unban, user == NULL\n");
	}
	return;
    }
    delmasklist(&chantab[chanid].bans, who);
//    docsettings(C_BAN, chanid, nick, who, 'b');
    delchanmodeid(chanid, '-', 'b', who);
}

void gotunexempt(int chanid, char *nick, char *host, char *who) {
    struct suser *user;
    int i;
    if (chantab[chanid].flags & CHAN_UNUSED) return;
    if (!nick) return;
    if (!nick[0] || (strlen(nick) > 9)) return;
    if (!who) return;
    if (!who[0]) return;
    if (!host) return;
    if (!host[0]) return;
    user=findchanuserid(chanid, nick);
    if (user == NULL) {
	if (!isclonenick(nick)) {
	    addchankickid(chanid, nick);
	    user->flags=USER_SENTKICK;
	    printf("exempt, user == NULL\n");
	}
	return;
    }
    delmasklist(&chantab[chanid].exempts, who);
//    docsettings(C_EXEMPT, chanid, nick, who, 'e');
    delchanmodeid(chanid, '-', 'e', who);
}

void gotuninvite(int chanid, char *nick, char *host, char *who) {
    struct suser *user;
    int i;
    if (chantab[chanid].flags & CHAN_UNUSED) return;
    if (!nick) return;
    if (!nick[0] || (strlen(nick) > 9)) return;
    if (!who) return;
    if (!who[0]) return;
    if (!host) return;
    if (!host[0]) return;
    user=findchanuserid(chanid, nick);
    if (user == NULL) {
	if (!isclonenick(nick)) {
	    addchankickid(chanid, nick);
	    user->flags=USER_SENTKICK;
	    printf("invite, user == NULL\n");
	}
	return;
    }
    delmasklist(&chantab[chanid].invites, who);
//    docsettings(C_INVITE, chanid, nick, who, 'I');
    delchanmodeid(chanid, '-', 'I', who);
}

void irc_ping(struct ssock *sock, struct sclonespecial *cs, char *prefix, char *params) {
    dprintf(sock->fd, "PONG %s\n", params);
}

void irc_welcome(struct ssock *sock, struct sclonespecial *cs, char *prefix, char *params) {
    int i;
    printf("irc_welcome\n");
    clonesstats.connected--;
    clonesstats.registered++;
    clonetab[cs->cid].status=CLONE_REGISTERED;
    for (i=0; i < MAXCHANNELS; i++) {
	clonetab[cs->cid].channels[i].flags=0;
	clonetab[cs->cid].channels[i].join=0;
	clonetab[cs->cid].channels[i].cmdcount=0;
    }
    for (i=0; i < MAXCHANNELS; i++) if (!(chantab[i].flags & CHAN_UNUSED)) clonejoinchanid(cs->cid, i);
}

void irc_mode(struct ssock *sock, struct sclonespecial *cs, char *prefix, char *params) {
    struct suser *user;
    int i, j, chanid;
    char *nick, *chan, *modes, *par[3];
    char pm;
    char limit[16];
    if (clonetab[cs->cid].status != CLONE_REGISTERED) return;
    if (!prefix) return;
    if (!prefix[0]) return;
    if (strcasecmp(prefix, clonetab[cs->cid].nick) == 0) return;
    nick=hostsplit(&prefix);
    chan=newsplit(&params);
    if (chan[0] == ':') chan++;
    chanid=findchanname(chan);
    if (chanid < 0) return;
    if (!(clonetab[cs->cid].channels[chanid].flags & CLONE_CHAN_ONCHAN)) return;
    if (!(clonetab[cs->cid].channels[chanid].flags & CLONE_CHAN_GOTNAMES)) return;
    clonetab[cs->cid].channels[chanid].cmdcount++;
    if (clonetab[cs->cid].channels[chanid].flags & CLONE_CHAN_SYNCHED) if (chantab[chanid].cmdcount >= clonetab[cs->cid].channels[chanid].cmdcount) return;
    chantab[chanid].cmdcount++;
    user=findchanuserid(chanid, nick);
    modes=newsplit(&params);
    if (modes[0] == ':') modes++;
    if (!modes[0]) return;
    par[0]=newsplit(&params);
    par[1]=newsplit(&params);
    par[2]=newsplit(&params);
    pm=modes[0];
    i=1; j=0;
    while (modes[i]) {
	switch (modes[i]) {
	case '+': pm='+'; break;
	case '-': pm='-'; break;
	case 'i': if (pm == '+') {
		      chantab[chanid].mode|=MODE_I; 
		      delchanmodeid(chanid, '+', 'i', NULL);
		      clonesjoinchanid(chanid);
		      if (chantab[chanid].modeprotm & MODE_I) {
		          addchanmodeid(chanid, '-', 'i', NULL);
		          if (chantab[chanid].copped && !ULMATCHFLAG(user->handle, 'm')) docsettings(C_CHANMODE, chanid, nick, NULL, ' ');
		      }
		  } else {
		      chantab[chanid].mode&=~MODE_I; 
		      delchanmodeid(chanid, '-', 'i', NULL);
		      if (chantab[chanid].modeprotp & MODE_I) {
		          addchanmodeid(chanid, '+', 'i', NULL);
		          if (chantab[chanid].copped && !ULMATCHFLAG(user->handle, 'm')) docsettings(C_CHANMODE, chanid, nick, NULL, ' ');
		      }
		  } break;
	case 'k': if (pm == '+') {
		      chantab[chanid].mode|=MODE_K; 
		      if (chantab[chanid].key) free(chantab[chanid].key);
		      chantab[chanid].key=(char *) malloc(strlen(par[j])+1);
		      strcpy(chantab[chanid].key, par[j]);
		      delchanmodeid(chanid, '+', 'k', par[j]);
		      j++;
		  } else {
		      chantab[chanid].mode&=~MODE_K; 
		      if (chantab[chanid].key) free(chantab[chanid].key);
		      chantab[chanid].key=NULL;
		      delchanmodeid(chanid, '-', 'k', par[j]);
		      j++;
		  }
		  if (chantab[chanid].keyprot && chantab[chanid].keyprot[0]) {
	              if (strcmp(chantab[chanid].key, chantab[chanid].keyprot)) {
		          if (chantab[chanid].key) addchanmodeid(chanid, '-', 'k', chantab[chanid].key);
		          addchanmodeid(chanid, '+', 'k', chantab[chanid].keyprot);
		      }
		      if (chantab[chanid].copped && !ULMATCHFLAG(user->handle, 'm')) docsettings(C_CHANMODE, chanid, nick, NULL, ' ');
		  } else if (chantab[chanid].modeprotm & MODE_K) {
		      addchanmodeid(chanid, '-', 'k', par[j]);
		      if (chantab[chanid].copped && !ULMATCHFLAG(user->handle, 'm')) docsettings(C_CHANMODE, chanid, nick, NULL, ' ');
		  }
		  break;
	case 'l': if (pm == '+') {
		      chantab[chanid].mode|=MODE_L;
		      chantab[chanid].limit=atoi(par[j]);
		      delchanmodeid(chanid, '+', 'l', par[j]);
		      if (chantab[chanid].modeprotm & MODE_I) addchanmodeid(chanid, '-', 'l', "");
		      j++; 
		  } else {
		      chantab[chanid].mode&=~MODE_L;
		      chantab[chanid].limit=0; 
		      delchanmodeid(chanid, '-', 'l', NULL);
		      clonesjoinchanid(chanid);
		      if (chantab[chanid].modeprotp & MODE_I) {
			  sprintf(limit, "%d", chantab[chanid].onchan+chantab[chanid].cjoin+chantab[chanid].cunjoin+10);
			  addchanmodeid(chanid, '+', 'l', limit);
		          if (chantab[chanid].copped && !ULMATCHFLAG(user->handle, 'm')) docsettings(C_CHANMODE, chanid, nick, NULL, ' ');
		      }
		  } break;
	case 'm': if (pm == '+') {
		      chantab[chanid].mode|=MODE_M; 
		      delchanmodeid(chanid, '+', 'm', NULL);
		      if (chantab[chanid].modeprotm & MODE_M) {
		          addchanmodeid(chanid, '-', 'm', NULL);
			  if (chantab[chanid].copped && !ULMATCHFLAG(user->handle, 'm')) docsettings(C_CHANMODE, chanid, nick, NULL, ' ');
		      }
		  } else {
		      chantab[chanid].mode&=~MODE_M; 
		      delchanmodeid(chanid, '-', 'm', NULL);
		      if (chantab[chanid].modeprotp & MODE_M) {
		          addchanmodeid(chanid, '+', 'm', NULL);
			  if (chantab[chanid].copped && !ULMATCHFLAG(user->handle, 'm')) docsettings(C_CHANMODE, chanid, nick, NULL, ' ');
		      }
		  } break;
	case 'n': if (pm == '+') {
		      chantab[chanid].mode|=MODE_N; 
		      delchanmodeid(chanid, '+', 'n', NULL);
		      if (chantab[chanid].modeprotm & MODE_N) {
		          addchanmodeid(chanid, '-', 'n', NULL);
			  if (chantab[chanid].copped && !ULMATCHFLAG(user->handle, 'm')) docsettings(C_CHANMODE, chanid, nick, NULL, ' ');
		      }
		  } else {
		      chantab[chanid].mode&=~MODE_N; 
		      delchanmodeid(chanid, '-', 'n', NULL);
		      if (chantab[chanid].modeprotp & MODE_N) {
		          addchanmodeid(chanid, '+', 'n', NULL);
			  if (chantab[chanid].copped && !ULMATCHFLAG(user->handle, 'm')) docsettings(C_CHANMODE, chanid, nick, NULL, ' ');
		      }
		  } break;
	case 'p': if (pm == '+') {
		      chantab[chanid].mode|=MODE_P; 
		      delchanmodeid(chanid, '+', 'p', NULL);
		      if (chantab[chanid].modeprotm & MODE_P) {
		          addchanmodeid(chanid, '-', 'p', NULL);
			  if (chantab[chanid].copped && !ULMATCHFLAG(user->handle, 'm')) docsettings(C_CHANMODE, chanid, nick, NULL, ' ');
		      }
		  } else {
		      chantab[chanid].mode&=~MODE_P; 
		      delchanmodeid(chanid, '-', 'p', NULL);
		      if (chantab[chanid].modeprotp & MODE_P) {
		          addchanmodeid(chanid, '+', 'p', NULL);
			  if (chantab[chanid].copped && !ULMATCHFLAG(user->handle, 'm')) docsettings(C_CHANMODE, chanid, nick, NULL, ' ');
		      }
		  } break;
	case 's': if (pm == '+') {
		      chantab[chanid].mode|=MODE_S; 
		      delchanmodeid(chanid, '+', 's', NULL);
		      if (chantab[chanid].modeprotm & MODE_S) {
		          addchanmodeid(chanid, '-', 's', NULL);
			  if (chantab[chanid].copped && !ULMATCHFLAG(user->handle, 'm')) docsettings(C_CHANMODE, chanid, nick, NULL, ' ');
		      }
		  } else {
		      chantab[chanid].mode&=~MODE_S; 
		      delchanmodeid(chanid, '-', 's', NULL);
		      if (chantab[chanid].modeprotp & MODE_S) {
		          addchanmodeid(chanid, '+', 's', NULL);
			  if (chantab[chanid].copped && !ULMATCHFLAG(user->handle, 'm')) docsettings(C_CHANMODE, chanid, nick, NULL, ' ');
		      }
		  } break;
	case 't': if (pm == '+') {
		      chantab[chanid].mode|=MODE_T; 
		      delchanmodeid(chanid, '+', 't', NULL);
		      if (chantab[chanid].modeprotm & MODE_T) {
		          addchanmodeid(chanid, '-', 't', NULL);
			  if (chantab[chanid].copped && !ULMATCHFLAG(user->handle, 'm')) docsettings(C_CHANMODE, chanid, nick, NULL, ' ');
		      }
		  } else {
		      chantab[chanid].mode&=~MODE_T; 
		      delchanmodeid(chanid, '-', 't', NULL);
		      if (chantab[chanid].modeprotp & MODE_T) {
		          addchanmodeid(chanid, '+', 't', NULL);
                          if (chantab[chanid].copped && !ULMATCHFLAG(user->handle, 'm')) docsettings(C_CHANMODE, chanid, nick, NULL, ' ');
		      }
		  } break;
	case 'o': if (pm == '+') gotop1(chanid, nick, prefix, par[j]); 
		  else gotdeop1(chanid, nick, prefix, par[j]);
		  j++;
		  break;
	case 'b': if (pm == '+') gotban(chanid, nick, prefix, par[j]); 
		  else gotunban(chanid, nick, prefix, par[j]);
		  j++;
		  break;
	case 'e': if (pm == '+') gotexempt(chanid, nick, prefix, par[j]); 
		  else gotunexempt(chanid, nick, prefix, par[j]);
		  j++;
		  break;
	case 'I': if (pm == '+') gotinvite(chanid, nick, prefix, par[j]); 
		  else gotuninvite(chanid, nick, prefix, par[j]);
		  j++;
		  break;
	}
	i++;
    }
    pm=modes[0];
    i=1; j=0;
    while (modes[i]) {
	switch (modes[i]) {
	case '+': pm='+'; break;
	case '-': pm='-'; break;
	case 'b': j++; break;
	case 'e': j++; break;
	case 'I': j++; break;
	case 'l': j++; break;
	case 'k': j++; break;
	case 'o': if (pm == '+') gotop2(chanid, nick, prefix, par[j]); 
		  else gotdeop2(chanid, nick, prefix, par[j]);
		  j++;
		  break;
	}
	i++;
    }
}

void irc_join(struct ssock *sock, struct sclonespecial *cs, char *prefix, char *params) {
    struct suser *user;
    int i, cid, chanid;
    char *nick;
    char *chan;
    if (clonetab[cs->cid].status != CLONE_REGISTERED) return;
    if (!prefix) return;
    if (!prefix[0]) return;
    nick=hostsplit(&prefix);
    chan=newsplit(&params);
    if (chan[0] == ':') chan++;
    chanid=findchanname(chan);
    if (chanid < 0) return;
    if (isclonenick(nick)) {
	cid=getclonenick(nick);
	printf("(%s (%x,%d,%s)) %s (%x,%d,%s) has join %s, CHANCNT=%d \n", 
		clonetab[cs->cid].nick, clonetab[cs->cid].channels[chanid].flags, clonetab[cs->cid].channels[chanid].cmdcount, (clonetab[cs->cid].channels[chanid].synccid<0)?"-":clonetab[clonetab[cs->cid].channels[chanid].synccid].nick,
		clonetab[cid].nick, clonetab[cid].channels[chanid].flags, clonetab[cid].channels[chanid].cmdcount, (clonetab[cid].channels[chanid].synccid<0)?"-":clonetab[clonetab[cid].channels[chanid].synccid].nick,
		chan, chantab[chanid].cmdcount);
    }
    if (strcasecmp(clonetab[cs->cid].nick, nick) == 0) {
	if (!(clonetab[cs->cid].channels[chanid].flags & CLONE_CHAN_ONCHAN) && (clonetab[cs->cid].channels[chanid].flags & CLONE_CHAN_SELFJOIN)) {
	    printf("1\n"); 
	    clonetab[cs->cid].channels[chanid].flags&=~CLONE_CHAN_SELFJOIN;
	    return;
	}
        clonetab[cs->cid].channels[chanid].flags&=~CLONE_CHAN_SELFJOIN;
	if (!(clonetab[cs->cid].channels[chanid].flags & CLONE_CHAN_ONCHAN) && (clonetab[cs->cid].channels[chanid].flags & CLONE_CHAN_SENTJOIN)) {
	    printf("2\n"); 
	    clonetab[cs->cid].channels[chanid].flags|=CLONE_CHAN_ONCHAN;
	    clonetab[cs->cid].channels[chanid].flags&=~CLONE_CHAN_SENTJOIN;
	    clonetab[cs->cid].channels[chanid].flags&=~CLONE_CHAN_SYNCHED;
	    clonetab[cs->cid].channels[chanid].cmdcount=0;
	    clonetab[cs->cid].channels[chanid].synccid=(-1);
	    if (!(chantab[chanid].flags & CHAN_SENTWHO) && !(chantab[chanid].flags & CHAN_GOTWHO)) {
		clonessendchanwhoid(chanid);
	    }
    	    clonessendchanmodebeiid(chanid);
	    if (chantab[chanid].copped) addchanmodeid(chanid, '+', 'o', nick);
	    user=addchanuserid(chanid, nick, prefix, 0);
	    chantab[chanid].onchan++;
	    chantab[chanid].conchan++;
	    chantab[chanid].cjoin--;
	    delchaninviteid(chanid, nick);
	} else if (clonetab[cs->cid].channels[chanid].flags & CLONE_CHAN_ONCHAN) {
	    printf("3\n"); 
	}
	return;
    }
    if (!(clonetab[cs->cid].channels[chanid].flags & CLONE_CHAN_ONCHAN)) return;
    if (!(clonetab[cs->cid].channels[chanid].flags & CLONE_CHAN_GOTNAMES)) return;
    if ((clonetab[cs->cid].channels[chanid].flags & CLONE_CHAN_SELFJOIN)) return;
    clonetab[cs->cid].channels[chanid].cmdcount++;
    if (clonetab[cs->cid].channels[chanid].flags & CLONE_CHAN_SYNCHED) if (chantab[chanid].cmdcount >= clonetab[cs->cid].channels[chanid].cmdcount) return;
    chantab[chanid].cmdcount++;
    if (isclonenick(nick)) {
	cid=getclonenick(nick);
	if (!(clonetab[cid].channels[chanid].flags & CLONE_CHAN_SYNCHED)) if ((chantab[chanid].conchan && (clonetab[cs->cid].channels[chanid].flags & CLONE_CHAN_SYNCHED)) || !chantab[chanid].conchan) {
	    printf("4\n"); 
	    clonetab[cid].channels[chanid].flags|=CLONE_CHAN_SYNCHED;
	    clonetab[cs->cid].channels[chanid].flags|=CLONE_CHAN_SYNCHED;
	    clonetab[cid].channels[chanid].cmdcount+=clonetab[cs->cid].channels[chanid].cmdcount;
	    clonetab[cid].channels[chanid].synccid=cs->cid;
	    if (!(clonetab[cid].channels[chanid].flags & CLONE_CHAN_ONCHAN) && (clonetab[cid].channels[chanid].flags & CLONE_CHAN_SENTJOIN)) {
		clonetab[cid].channels[chanid].flags|=CLONE_CHAN_ONCHAN;
		clonetab[cid].channels[chanid].flags&=~CLONE_CHAN_SENTJOIN;
		clonetab[cid].channels[chanid].flags|=CLONE_CHAN_SELFJOIN;
		clonetab[cid].channels[chanid].synccid=(-1);
//		clonetab[cid].channels[chanid].flags&=~CLONE_CHAN_SENTJOIN;
		if (!(chantab[chanid].flags & CHAN_SENTWHO) && !(chantab[chanid].flags & CHAN_GOTWHO)) {
		    clonessendchanwhoid(chanid);
		}
    		clonessendchanmodebeiid(chanid);
		if (chantab[chanid].copped) addchanmodeid(chanid, '+', 'o', nick);
		user=addchanuserid(chanid, nick, prefix, 0);
		printf("5\n"); 
		chantab[chanid].conchan++;
		chantab[chanid].onchan++;
		chantab[chanid].cjoin--;
	    }
	} else if (chantab[chanid].conchan) {
	    clonetab[cs->cid].channels[chanid].flags|=CLONE_CHAN_SYNCHED;
	    clonetab[cid].channels[chanid].cmdcount+=clonetab[cs->cid].channels[chanid].cmdcount;
	    clonetab[cid].channels[chanid].synccid=cs->cid;
	    printf("6\n"); 
	    for (i=0; i < MAXCLONES; i++) if (clonetab[i].status == CLONE_REGISTERED)
		if ((clonetab[i].channels[chanid].flags & CLONE_CHAN_ONCHAN) && (clonetab[i].channels[chanid].flags & CLONE_CHAN_SYNCHED) && (clonetab[i].channels[chanid].synccid == cid)) {
		    clonetab[i].channels[chanid].synccid=cs->cid;
		    clonetab[i].channels[chanid].cmdcount+=clonetab[cs->cid].channels[chanid].cmdcount;
		}
	}
    } else {
	user=addchanuserid(chanid, nick, prefix, 0);
	printf("(%s) %s has join %s\n", clonetab[cs->cid].nick, nick, chan);
	chantab[chanid].onchan++;
	if (ULMATCHFLAG(user->handle, 'o') && ULMATCHFLAG(user->handle, 'a')) if (chantab[chanid].copped) addchanmodeid(chanid, '+', 'o', nick);
    }
    delchaninviteid(chanid, nick);
}

void irc_nick(struct ssock *sock, struct sclonespecial *cs, char *prefix, char *params) {
    struct suser *user;
    int i;
    char *nick;
    char *newnick;
    if (clonetab[cs->cid].status != CLONE_REGISTERED) return;
    if (!prefix) return;
    if (!prefix[0]) return;
    nick=hostsplit(&prefix);
    newnick=newsplit(&params);
    if (newnick[0] == ':') newnick++;
    for (i=0; i < MAXCHANNELS; i++) {
	if (!(clonetab[cs->cid].channels[i].flags & CLONE_CHAN_ONCHAN)) return;
	if (!(clonetab[cs->cid].channels[i].flags & CLONE_CHAN_GOTNAMES)) return;
	clonetab[cs->cid].channels[i].cmdcount++;
	if (clonetab[cs->cid].channels[i].flags & CLONE_CHAN_SYNCHED) if (chantab[i].cmdcount >= clonetab[cs->cid].channels[i].cmdcount) return;
	chantab[i].cmdcount++;
	printf("(%s) %s has changed nick to %s\n", clonetab[cs->cid].nick, nick, newnick);
	user=findchanuserid(i, nick);
	if (user) {
	    strcpy(user->nick, newnick);
	}
    }
}

void irc_namesreply(struct ssock *sock, struct sclonespecial *cs, char *prefix, char *params) {
    struct suser *user;
    int i, cid, chanid;
    char *mynick;
    char *nick;
    char *chan;
    char *status;
    if (clonetab[cs->cid].status != CLONE_REGISTERED) return;
    if (!prefix) return;
    if (!prefix[0]) return;
    mynick=newsplit(&params);
    status=newsplit(&params);
    chan=newsplit(&params);
    if (chan[0] == ':') chan++;
    chanid=findchanname(chan);
    if (chanid < 0) return;
    if (!(clonetab[cs->cid].channels[chanid].flags & CLONE_CHAN_SENTNAMES)) return;
    nick=newsplit(&params);
    if (nick[0] == ':') nick++;
    while (nick && nick[0]) {
	switch (nick[0]) {
	case '@': user=addchanuserid(chanid, (char *) (nick+1), NULL, USER_HASOP | USER_OP); nick++; break;
	case '+': user=addchanuserid(chanid, (char *) (nick+1), NULL, 0); nick++; break;
	default:  user=addchanuserid(chanid, (char *) (nick), NULL, 0); break;
	}
	if (!user) return;
//	if (!(user->flags & USER_ALREADY)) {
//	    chantab[chanid].onchan++;
//	    if (user->flags & USER_OP) chantab[chanid].opped++;
//	}
	nick=newsplit(&params);
    }
}

void irc_namesend(struct ssock *sock, struct sclonespecial *cs, char *prefix, char *params) {
    int i, chanid;
    char *mynick;
    char *nick;
    char *chan;
    char *status;
    if (clonetab[cs->cid].status != CLONE_REGISTERED) return;
    if (!prefix) return;
    if (!prefix[0]) return;
    mynick=newsplit(&params);
    chan=newsplit(&params);
    if (chan[0] == ':') chan++;
    chanid=findchanname(chan);
    if (chanid < 0) return;
    if (!(clonetab[cs->cid].channels[chanid].flags & CLONE_CHAN_SENTNAMES)) return;
    clonetab[cs->cid].channels[chanid].flags&=~CLONE_CHAN_SENTNAMES;
    clonetab[cs->cid].channels[chanid].flags|=CLONE_CHAN_GOTNAMES;
}

void irc_whoreply(struct ssock *sock, struct sclonespecial *cs, char *prefix, char *params) {
    struct suser *user;
    int i, chanid;
    char *mynick;
    char *chan;
    char *ident, *name, *server, *nick, *host, *flags;
    if (clonetab[cs->cid].status != CLONE_REGISTERED) return;
    if (!prefix) return;
    if (!prefix[0]) return;
    mynick=newsplit(&params);
    chan=newsplit(&params);
    if (chan[0] == ':') chan++;
    chanid=findchanname(chan);
    if (chanid < 0) return;
    if (!(clonetab[cs->cid].channels[chanid].flags & CLONE_CHAN_SENTWHO)) return;
    if (!(chantab[chanid].flags & CHAN_SENTWHO)) return;
    ident=newsplit(&params);
    name=newsplit(&params);
    server=newsplit(&params);
    nick=newsplit(&params);
    flags=newsplit(&params);
    host=malloc(strlen(ident)+strlen(name)+2);
    sprintf(host, "%s@%s", ident, name);
    user=addchanuserid(chanid, nick, host, (flags[1]=='@')?(USER_HASOP | USER_OP):0);
    if (!(user->flags & USER_ALREADY) || ((user->flags & USER_ALREADY) && (user->flags & USER_HOST))) {
	chantab[chanid].onchan++;
	if (flags[1]=='@') chantab[chanid].opped++;
    }
    free(host);
    if (!user) return;
}

void irc_whoend(struct ssock *sock, struct sclonespecial *cs, char *prefix, char *params) {
    int i, chanid;
    char *mynick;
    char *nick;
    char *chan;
    char *status;
    if (clonetab[cs->cid].status != CLONE_REGISTERED) return;
    if (!prefix) return;
    if (!prefix[0]) return;
    mynick=newsplit(&params);
    chan=newsplit(&params);
    if (chan[0] == ':') chan++;
    chanid=findchanname(chan);
    if (chanid < 0) return;
    if (!(clonetab[cs->cid].channels[chanid].flags & CLONE_CHAN_SENTWHO)) return;
    if (!(chantab[chanid].flags & CHAN_SENTWHO)) return;
    clonetab[cs->cid].channels[chanid].flags&=~CLONE_CHAN_SENTWHO;
    chantab[chanid].flags&=~CHAN_SENTWHO;
    chantab[chanid].flags|=CHAN_GOTWHO;
    printf("Got WHO\n");
}

int parsechanmode(int old, char *modes) {
    int i, ret;
    char pm;
    if (!modes) return 0;
    if ((modes[0] != '+') && (modes[0] != '-')) return 0;
    pm=modes[0];
    i=1;
    ret=old;
    while (modes[i]) {
	switch (modes[i]) {
	case '+': pm='+';
	case '-': pm='-';
	case 'i': if (pm == '+') ret|=MODE_I; else ret&=~MODE_I; break;
	case 'k': if (pm == '+') ret|=MODE_K; else ret&=~MODE_K; break;
	case 'l': if (pm == '+') ret|=MODE_L; else ret&=~MODE_L; break;
	case 'm': if (pm == '+') ret|=MODE_M; else ret&=~MODE_M; break;
	case 'n': if (pm == '+') ret|=MODE_N; else ret&=~MODE_N; break;
	case 'p': if (pm == '+') ret|=MODE_P; else ret&=~MODE_P; break;
	case 's': if (pm == '+') ret|=MODE_S; else ret&=~MODE_S; break;
	case 't': if (pm == '+') ret|=MODE_T; else ret&=~MODE_T; break;
	}
	i++;
    }
    return ret;
}

int parsechanmodelimit(int old, char *modes, char *par) {
    int i, ret;
    char *limit;
    if (!modes) return 0;
    if (modes[0] != '+') return 0;
    if (!par) return 0;
    if (!par[0]) return 0;
    if (!(parsechanmode(old, modes) & MODE_L)) return 0;
    limit=newsplit(&par);
    return atoi(limit);
}

void irc_chanmode(struct ssock *sock, struct sclonespecial *cs, char *prefix, char *params) {
    int i, chanid;
    char *mynick;
    char *nick;
    char *chan;
    char *modes;
    char *status;
    if (clonetab[cs->cid].status != CLONE_REGISTERED) return;
    if (!prefix) return;
    if (!prefix[0]) return;
    mynick=newsplit(&params);
    chan=newsplit(&params);
    if (chan[0] == ':') chan++;
    chanid=findchanname(chan);
    if (chanid < 0) return;
    if (!(clonetab[cs->cid].channels[chanid].flags & CLONE_CHAN_SENTMODE)) return;
    if (!(chantab[chanid].flags & CHAN_SENTMODE)) return;
    clonetab[cs->cid].channels[chanid].flags&=~CLONE_CHAN_SENTMODE;
    chantab[chanid].flags&=~CHAN_SENTMODE;
    chantab[chanid].flags|=CHAN_GOTMODE;
    printf("Got MODE\n");
    modes=newsplit(&params);
    chantab[chanid].mode=parsechanmode(0, modes);
    chantab[chanid].limit=parsechanmodelimit(0, modes, params);
}

void irc_kick(struct ssock *sock, struct sclonespecial *cs, char *prefix, char *params) {
    struct suser *kicker, *kicked;
    int i, cid, chanid;
    char *nick, *nick2;
    char *chan;
    char *status;
    if (clonetab[cs->cid].status != CLONE_REGISTERED) return;
    if (!prefix) return;
    if (!prefix[0]) return;
    nick=hostsplit(&prefix);
    chan=newsplit(&params);
    if (chan[0] == ':') chan++;
    chanid=findchanname(chan);
    if (chanid < 0) return;
    if (!(clonetab[cs->cid].channels[chanid].flags & CLONE_CHAN_ONCHAN)) return;
    if (!(clonetab[cs->cid].channels[chanid].flags & CLONE_CHAN_GOTNAMES)) return;
    clonetab[cs->cid].channels[chanid].cmdcount++;
    if (clonetab[cs->cid].channels[chanid].flags & CLONE_CHAN_SYNCHED) if (chantab[chanid].cmdcount >= clonetab[cs->cid].channels[chanid].cmdcount) return;
    chantab[chanid].cmdcount++;
    nick2=newsplit(&params);
    if (nick2[0] == ':') nick2++;
    if (!(clonetab[cs->cid].channels[chanid].flags & CLONE_CHAN_GOTNAMES)) return;
    kicker=findchanuserid(chanid, nick);
    kicked=findchanuserid(chanid, nick2);
    if (kicker == NULL) return;
    if (kicked == NULL) return;
    printf("(%s) %s kicked %s on %s\n", clonetab[cs->cid].nick, nick, nick2, chan);
    chantab[chanid].onchan--;
    if (isopchannickid(chanid, nick2)) chantab[chanid].opped--;
    if (isclonenick(nick2)) {
	cid=getclonenick(nick2);
	if ((clonetab[cid].channels[chanid].flags & CLONE_CHAN_ONCHAN)) {
	    chantab[chanid].conchan--;
	    if (isopchannickid(chanid, clonetab[cid].nick)) chantab[chanid].copped--;
	    clonetab[cid].channels[chanid].flags&=~CLONE_CHAN_ONCHAN;
	    clonetab[cid].channels[chanid].flags&=~CLONE_CHAN_SENTJOIN;
	    clonetab[cid].channels[chanid].flags&=~CLONE_CHAN_GOTNAMES;
	    clonetab[cid].channels[chanid].flags&=~CLONE_CHAN_SYNCHED;
	    clonetab[cid].channels[chanid].cmdcount=0;
	    clonetab[cid].channels[chanid].synccid=(-1);
	    clonejoinchanid(cid, chanid);
	    if (chantab[chanid].copped) {
		resendchankickid(chanid, cid);
		resendchanmodeid(chanid, cid);
		resendchaninviteid(chanid, cid);
		if (!ULMATCHFLAG(kicker->handle, 'm')) docsettings(C_REVANGE, chanid, nick, nick2, '*');
	    } else {
		chantab[chanid].cflags|=CHAN_C_AFTEROP;
		delchankickid(chanid, "*");
		delchanmodeid(chanid, '*', '*', NULL);
		delchaninviteid(chanid, "*");
	    }
	    if (!chantab[chanid].conchan) chantab[chanid].cmdcount=0;
	    if ((clonetab[cid].channels[chanid].flags & CLONE_CHAN_SENTWHO) && (chantab[chanid].flags & CHAN_SENTWHO)) {
		clonetab[cid].channels[chanid].flags&=~CLONE_CHAN_SENTWHO;
		chantab[chanid].flags&=~CHAN_SENTWHO;
		clonessendchanwhoid(chanid);
	    }
	    if (((clonetab[cid].channels[chanid].flags & CLONE_CHAN_SENTMODE) && (chantab[chanid].flags & CHAN_SENTMODE)) ||
	        ((clonetab[cid].channels[chanid].flags & CLONE_CHAN_SENTBANLIST) && (chantab[chanid].flags & CHAN_SENTBANLIST)) ||
		((clonetab[cid].channels[chanid].flags & CLONE_CHAN_SENTEXEMPTLIST) && (chantab[chanid].flags & CHAN_SENTEXEMPTLIST)) ||
	        ((clonetab[cid].channels[chanid].flags & CLONE_CHAN_SENTINVITELIST) && (chantab[chanid].flags & CHAN_SENTINVITELIST))) {
		clonetab[cid].channels[chanid].flags&=~CLONE_CHAN_SENTMODE;
		chantab[chanid].flags&=~CHAN_SENTMODE;
		clonetab[cid].channels[chanid].flags&=~CLONE_CHAN_SENTBANLIST;
		chantab[chanid].flags&=~CHAN_SENTBANLIST;
		clonetab[cid].channels[chanid].flags&=~CLONE_CHAN_SENTEXEMPTLIST;
		chantab[chanid].flags&=~CHAN_SENTEXEMPTLIST;
		clonetab[cid].channels[chanid].flags&=~CLONE_CHAN_SENTINVITELIST;
		chantab[chanid].flags&=~CHAN_SENTINVITELIST;
    		clonessendchanmodebeiid(chanid);
	    }
	}
    } else if (isclonenick(nick)) {
    } else {
        if (chantab[chanid].copped && ULMATCHFLAG(kicked->handle, 'm') && !ULMATCHFLAG(kicker->handle, 'm')) docsettings(C_REVANGE, chanid, nick, nick2, '*');
    }
    delchankickid(chanid, nick2);
    delchanmodeid(chanid, '*', '*', nick2);
    delchanuserid(chanid, nick2);
}

void irc_part(struct ssock *sock, struct sclonespecial *cs, char *prefix, char *params) {
    struct suser *user;
    int i, chanid;
    char *nick;
    char *chan;
    if (clonetab[cs->cid].status != CLONE_REGISTERED) return;
    if (!prefix) return;
    if (!prefix[0]) return;
    nick=hostsplit(&prefix);
    chan=newsplit(&params);
    if (chan[0] == ':') chan++;
    chanid=findchanname(chan);
    if (chanid < 0) return;
    if (!(clonetab[cs->cid].channels[chanid].flags & CLONE_CHAN_ONCHAN)) return;
    if (!(clonetab[cs->cid].channels[chanid].flags & CLONE_CHAN_GOTNAMES)) return;
    clonetab[cs->cid].channels[chanid].cmdcount++;
    if (clonetab[cs->cid].channels[chanid].flags & CLONE_CHAN_SYNCHED) if (chantab[chanid].cmdcount >= clonetab[cs->cid].channels[chanid].cmdcount) return;
    chantab[chanid].cmdcount++;
    printf("(%s) %s has left %s\n", clonetab[cs->cid].nick, nick, chan);
    user=findchanuserid(chanid, nick);
    if (!user) return;
    chantab[chanid].onchan--;
    if (isopchannickid(chanid, nick)) chantab[chanid].opped--;
    delchanmodeid(chanid, '*', '*', nick);
    delchankickid(chanid, nick);
    delchaninviteid(chanid, nick);
    delchanuserid(chanid, nick);
}

void irc_quit(struct ssock *sock, struct sclonespecial *cs, char *prefix, char *params) {
    struct suser *user;
    int i, cid;
    char *nick;
    if (clonetab[cs->cid].status != CLONE_REGISTERED) return;
    if (!prefix) return;
    if (!prefix[0]) return;
    nick=hostsplit(&prefix);
    for (i=0; i < MAXCHANNELS; i++) if (!(chantab[i].flags & CHAN_UNUSED)) {
	if (!(clonetab[cs->cid].channels[i].flags & CLONE_CHAN_ONCHAN)) break;
	if (!(clonetab[cs->cid].channels[i].flags & CLONE_CHAN_GOTNAMES)) break;
	clonetab[cs->cid].channels[i].cmdcount++;
	if (clonetab[cs->cid].channels[i].flags & CLONE_CHAN_SYNCHED) if (chantab[i].cmdcount >= clonetab[cs->cid].channels[i].cmdcount) break;
	chantab[i].cmdcount++;
	if (isclonenick(nick)) {
	    cid=getclonenick(nick);
	    if ((clonetab[cid].channels[i].flags & CLONE_CHAN_ONCHAN)) {
		chantab[i].conchan--;
		chantab[i].onchan--;
		if (isopchannickid(i, clonetab[cid].nick)) {
		    chantab[i].copped--;
		    chantab[i].opped--;
		}
		clonetab[cid].channels[i].flags&=~CLONE_CHAN_ONCHAN;
		clonetab[cid].channels[i].flags&=~CLONE_CHAN_SENTJOIN;
		clonetab[cid].channels[i].flags&=~CLONE_CHAN_GOTNAMES;
		clonetab[cid].channels[i].flags&=~CLONE_CHAN_SYNCHED;
		clonetab[cid].channels[i].cmdcount=0;
		if (chantab[i].copped) {
		    resendchankickid(i, cid);
		    resendchanmodeid(i, cid);
		    resendchaninviteid(i, cid);
		    delchanmodeid(i, '*', '*', nick);
		} else {
		    chantab[i].cflags|=CHAN_C_AFTEROP;
		    delchankickid(i, "*");
		    delchanmodeid(i, '*', '*', NULL);
		    delchaninviteid(i, "*");
		}
		if (!chantab[i].conchan) chantab[i].cmdcount=0;
		if ((clonetab[cid].channels[i].flags & CLONE_CHAN_SENTWHO) && (chantab[i].flags & CHAN_SENTWHO)) {
		    clonetab[cid].channels[i].flags&=~CLONE_CHAN_SENTWHO;
		    chantab[i].flags&=~CHAN_SENTWHO;
		    clonessendchanwhoid(i);
		}
		if (((clonetab[cid].channels[i].flags & CLONE_CHAN_SENTMODE) && (chantab[i].flags & CHAN_SENTMODE)) ||
	    	    ((clonetab[cid].channels[i].flags & CLONE_CHAN_SENTBANLIST) && (chantab[i].flags & CHAN_SENTBANLIST)) ||
		    ((clonetab[cid].channels[i].flags & CLONE_CHAN_SENTEXEMPTLIST) && (chantab[i].flags & CHAN_SENTEXEMPTLIST)) ||
	    	    ((clonetab[cid].channels[i].flags & CLONE_CHAN_SENTINVITELIST) && (chantab[i].flags & CHAN_SENTINVITELIST))) {
		    clonetab[cid].channels[i].flags&=~CLONE_CHAN_SENTMODE;
		    chantab[i].flags&=~CHAN_SENTMODE;
		    clonetab[cid].channels[i].flags&=~CLONE_CHAN_SENTBANLIST;
		    chantab[i].flags&=~CHAN_SENTBANLIST;
		    clonetab[cid].channels[i].flags&=~CLONE_CHAN_SENTEXEMPTLIST;
		    chantab[i].flags&=~CHAN_SENTEXEMPTLIST;
		    clonetab[cid].channels[i].flags&=~CLONE_CHAN_SENTINVITELIST;
		    chantab[i].flags&=~CHAN_SENTINVITELIST;
    		    clonessendchanmodebeiid(i);
		}
	    }
	} else {
	    chantab[i].onchan--;
	    if (isopchannickid(i, nick)) chantab[i].opped--;
	}
	delchanmodeid(i, '*', '*', nick);
	delchankickid(i, nick);
	delchanuserid(i, nick);
    }
}

void irc_invite(struct ssock *sock, struct sclonespecial *cs, char *prefix, char *params) {
    struct suser *user;
    int i, chanid;
    char *nick, *chan;
    if (clonetab[cs->cid].status != CLONE_REGISTERED) return;
    if (!prefix) return;
    if (!prefix[0]) return;
    nick=newsplit(&params);
    chan=newsplit(&params);
    if (chan[0] == ':') chan++;
    chanid=findchanname(chan);
    if (chanid < 0) return;
    if (!(chantab[chanid].flags & CHAN_JOIN)) return;
    if (clonetab[cs->cid].channels[chanid].flags & CLONE_CHAN_ONCHAN) return;
    if (!(clonetab[cs->cid].channels[chanid].flags & CLONE_CHAN_UNJOIN)) return;
    clonetab[cs->cid].channels[chanid].flags&=~CLONE_CHAN_UNJOIN;
    chantab[chanid].cunjoin--;
    clonejoinchanid(cs->cid, chanid);
    printf("Got invite %s %s\n", chan, nick);
}

void irc_needlimit(struct ssock *sock, struct sclonespecial *cs, char *prefix, char *params) {
    struct suser *user;
    int i, chanid;
    char *mynick;
    char *chan;
    char limit[16];
    if (clonetab[cs->cid].status != CLONE_REGISTERED) return;
    if (!prefix) return;
    if (!prefix[0]) return;
    mynick=newsplit(&params);
    chan=newsplit(&params);
    if (chan[0] == ':') chan++;
    chanid=findchanname(chan);
    if (chanid < 0) return;
    clonetab[cs->cid].channels[chanid].flags&=~CLONE_CHAN_SENTJOIN;
    clonetab[cs->cid].channels[chanid].flags&=~CLONE_CHAN_SENTNAMES;
    clonetab[cs->cid].channels[chanid].flags&=~CLONE_CHAN_ONCHAN;
    chantab[chanid].cjoin--;
    if (!(chantab[chanid].flags & CHAN_JOIN)) return;
    if (!(clonetab[cs->cid].channels[chanid].flags & CLONE_CHAN_UNJOIN)) chantab[chanid].cunjoin++;
    clonetab[cs->cid].channels[chanid].flags|=CLONE_CHAN_NEEDLIMIT;
    if (!chantab[chanid].conchan || !chantab[chanid].copped) return;
    clonejoinchanid(cs->cid, chanid);
}

void irc_needinvite(struct ssock *sock, struct sclonespecial *cs, char *prefix, char *params) {
    struct suser *user;
    int i, chanid;
    char *mynick;
    char *chan;
    if (clonetab[cs->cid].status != CLONE_REGISTERED) return;
    if (!prefix) return;
    if (!prefix[0]) return;
    mynick=newsplit(&params);
    chan=newsplit(&params);
    if (chan[0] == ':') chan++;
    chanid=findchanname(chan);
    if (chanid < 0) return;
    clonetab[cs->cid].channels[chanid].flags&=~CLONE_CHAN_SENTJOIN;
    clonetab[cs->cid].channels[chanid].flags&=~CLONE_CHAN_SENTNAMES;
    clonetab[cs->cid].channels[chanid].flags&=~CLONE_CHAN_ONCHAN;
    chantab[chanid].cjoin--;
    if (!(chantab[chanid].flags & CHAN_JOIN)) return;
    if (!(clonetab[cs->cid].channels[chanid].flags & CLONE_CHAN_UNJOIN)) chantab[chanid].cunjoin++;
    clonetab[cs->cid].channels[chanid].flags|=CLONE_CHAN_NEEDINVITE;
    if (!chantab[chanid].conchan || !chantab[chanid].copped) return;
    clonejoinchanid(cs->cid, chanid);
}

void irc_banned(struct ssock *sock, struct sclonespecial *cs, char *prefix, char *params) {
    struct suser *user;
    int i, chanid;
    char *mynick;
    char *chan;
    if (clonetab[cs->cid].status != CLONE_REGISTERED) return;
    if (!prefix) return;
    if (!prefix[0]) return;
    mynick=newsplit(&params);
    chan=newsplit(&params);
    if (chan[0] == ':') chan++;
    chanid=findchanname(chan);
    if (chanid < 0) return;
    clonetab[cs->cid].channels[chanid].flags&=~CLONE_CHAN_SENTJOIN;
    clonetab[cs->cid].channels[chanid].flags&=~CLONE_CHAN_SENTNAMES;
    clonetab[cs->cid].channels[chanid].flags&=~CLONE_CHAN_ONCHAN;
    chantab[chanid].cjoin--;
    if (!(chantab[chanid].flags & CHAN_JOIN)) return;
    if (!(clonetab[cs->cid].channels[chanid].flags & CLONE_CHAN_UNJOIN)) chantab[chanid].cunjoin++;
    clonetab[cs->cid].channels[chanid].flags|=CLONE_CHAN_BANNED;
    if (!chantab[chanid].conchan || !chantab[chanid].copped) return;
    clonejoinchanid(cs->cid, chanid);
}

void irc_needkey(struct ssock *sock, struct sclonespecial *cs, char *prefix, char *params) {
    struct suser *user;
    int i, chanid;
    char *mynick;
    char *chan;
    if (clonetab[cs->cid].status != CLONE_REGISTERED) return;
    if (!prefix) return;
    if (!prefix[0]) return;
    mynick=newsplit(&params);
    chan=newsplit(&params);
    if (chan[0] == ':') chan++;
    chanid=findchanname(chan);
    if (chanid < 0) return;
    clonetab[cs->cid].channels[chanid].flags&=~CLONE_CHAN_SENTJOIN;
    clonetab[cs->cid].channels[chanid].flags&=~CLONE_CHAN_SENTNAMES;
    clonetab[cs->cid].channels[chanid].flags&=~CLONE_CHAN_ONCHAN;
    chantab[chanid].cjoin--;
    if (!(chantab[chanid].flags & CHAN_JOIN)) return;
    if (!(clonetab[cs->cid].channels[chanid].flags & CLONE_CHAN_UNJOIN)) chantab[chanid].cunjoin++;
    clonetab[cs->cid].channels[chanid].flags|=CLONE_CHAN_NEEDKEY;
    if (!chantab[chanid].conchan) return;
    clonejoinchanid(cs->cid, chanid);
}

struct scalllistlist callirc[] = {
    {"001",		&irc_welcome},
    {"353",		&irc_namesreply},
    {"366",		&irc_namesend},
    {"352",		&irc_whoreply},
    {"315",		&irc_whoend},
    {"324",		&irc_chanmode},
    {"471",		&irc_needlimit},
    {"473",		&irc_needinvite},
    {"474",		&irc_banned},
    {"475",		&irc_needkey},
    {"PING",		&irc_ping},
    {"MODE",		&irc_mode},
    {"JOIN",		&irc_join},
    {"NICK",		&irc_nick},
    {"KICK",		&irc_kick},
    {"PART",		&irc_part},
    {"QUIT",		&irc_quit},
    {"INVITE",		&irc_invite},
    {NULL, NULL},
};

void initclones() {
    int i;
    printf("*** Clones ***\n");
    for (i=0; i < MAXCLONES; i++) clonetab[i].status=CLONE_FREE;
    clonesstats.connect=0;
    clonesstats.connected=0;
    clonesstats.registered=0;
    addcall(&calls, CALL_IRC);
    addcallidlist(&calls, CALL_IRC, (struct scalllistlist *) &callirc);
    printf("Max clones:      %d\n", MAXCLONES);
    printf("Reconnect time:  %ds\n", RECONNECTTIME);
}

int cloneidle() {
    static lastpenalty=0;
    struct sclonespecial *p;
    register int i, j, k;
    int ret, sid;
    char *s;
    if (now != lastpenalty) {
        for (i=0; i < MAXCLONES; i++) 
	    if ((clonetab[i].status == CLONE_CONNECTED) || (clonetab[i].status == CLONE_REGISTERED)) if (clonetab[i].penalty) clonetab[i].penalty--;
    	lastpenalty=now;
	for (i=0; i < MAXCHANNELS; i++) 
	    if (!(chantab[i].flags & CHAN_UNUSED) && (chantab[i].flags & CHAN_JOIN)) {
		clonesjoinchanid(i);
	    	clonessendchanwhoid(i);
		clonessendchanmodebeiid(i);
	    }
    }
    for (i=0; i < MAXCLONES; i++) if (clonetab[i].status == CLONE_DISCONNECTED) {
	sid=clonetab[i].sid;
	if (clonetab[i].time < now) {
	    if (clonesservipv6) ret=socket_create(SOCKTYPE_NORMAL6, 0, clone_onconnect, clone_ondisconnect, clone_onrecv, clone_onclose, clone_onerror);
		else ret=socket_create(SOCKTYPE_NORMAL, 0, clone_onconnect, clone_ondisconnect, clone_onrecv, clone_onclose, clone_onerror);
	    if (ret < 0) {
		ERROR0("reconnect: Create socket error.");
		return (-1);
	    }
	    sid=ret;
	    socktab[sid].special=NULL;
	    ret=socket_bind(sid, getnexthost(), 0);
	    if (!ret) {
	        ERROR0("addclone: Bind error.");
	    }
	    ret=socket_connect(sid, clonesserv, clonesport);
	    if (!ret) {
		ERROR0("reconnect: Connect error.");
		socket_closeid(sid);
		return (-1);
	    }
	    clonetab[i].time=0;
	    clonetab[i].status=CLONE_CONNECT;
	    clonetab[i].penalty=0;
	    p=(struct sclonespecial *) malloc(sizeof(struct sclonespecial));
	    p->cid=i;
	    socktab[sid].special=(void *) p;
	    for (j=0; j < MAXCHANNELS; j++) {
		clonetab[i].channels[j].flags=0;
	    }
	}
    }
    return 0;
}
